      SUBROUTINE MOCROB
C     ******************************************************************
C     Read observation locations
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      READ(IUREAL(IUCOBS),*) NUMOBS,IOBSFL
      WRITE(IOUT,*) ' NUMOBS=',NUMOBS,'   IOBSFL=',IOBSFL
      IF(NUMOBS.GT.MXCOB) THEN
         WRITE(IOUT,*) ' In MFI, NUMOBS cannot exceed MXCOB:',MXCOB
         CALL RDABRT
      END IF
      IF(NUMOBS.GT.0) THEN
         WRITE(IOUT,2)
2        FORMAT(' Concentration Observation Wells',/
     1          ' Layer  Row  Column  I/O Unit')
         DO 10 I=1,NUMOBS
         READ(IUREAL(IUCOBS),*) (ICOB(J,I),J=1,3),ICOBFL(I)
         WRITE(IOUT,'(I5,I5,I8,I10)') (ICOB(J,I),J=1,3),ICOBFL(I)
10       CONTINUE
C
         IF(IOBSFL.GT.0) THEN
            IF(ICOBFL(1).LE.0 .OR. FILTYP(ICOBFL(1)).NE.'DATA' .OR.
     1         IFNUSE(ICOBFL(1)).NE.IUMOC) THEN
               WRITE(IOUT,*) ' Invalid output file unit specified for',
     1      ' observation data in the'
               WRITE(IOUT,*) ' list of observation wells:',ICOBFL(1)
               WRITE(IOUT,*) ' Observation data can only be stored in',
     1      ' files specified in the MOC'
               WRITE(IOUT,*) ' name file using type DATA'
               CALL RDABRT
            END IF
            IOBSFL=ICOBFL(1)
            DO 20 I=1,NUMOBS
            ICOBFL(I)=0
20          CONTINUE
         ELSE
            DO 40 I=1,NUMOBS
            IF(ICOBFL(I).LE.0 .OR. FILTYP(ICOBFL(I)).NE.'DATA' .OR.
     1         IFNUSE(ICOBFL(I)).NE.IUMOC) THEN
               WRITE(IOUT,*) ' Invalid output file unit specified for',
     1      ' observation data in the'
               WRITE(IOUT,*) ' list of observation wells:',ICOBFL(I)
               WRITE(IOUT,*) ' Observation data can only be stored in',
     1      ' files specified in the MOC'
               WRITE(IOUT,*) ' name file using type DATA'
               CALL RDABRT
            END IF
40          CONTINUE
            IOBSFL=0
         END IF
      ELSE
         IOBSFL=0
      END IF
      CALL IVLSAV('IOBSFL',0,0,IOBSFL)
C
      CLOSE(UNIT=IUREAL(IUCOBS))
      RETURN
      END
      SUBROUTINE MOCRRC
C     ******************************************************************
C     Read recharge concentrations
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*24 ANAME
      DATA ANAME/'Recharge Concentration  '/
C     ------------------------------------------------------------------
      IF(IUNIT(8).EQ.0) THEN
         CLOSE(UNIT=IUREAL(IUCRC))
         IFNUSE(IUCRC)=0
         IUCRC=0
         RETURN
      END IF
C
      DO 100 KPER=1,NPER
      READ(IUREAL(IUCRC),*) INCRCH
      CALL ARRMAK('CRECH',0,KPER,NSCOL,NSROW)
      IF(INCRCH.GT.0) THEN
         CALL U2DREL(ANAME,NSROW,NSCOL,0,IUCRC,NARRAY,IUMOC)
      ELSE
         IARRDA(1,NARRAY)=-3
      END IF
100   CONTINUE
C
      CLOSE(UNIT=IUREAL(IUCRC))
      RETURN
      END
      SUBROUTINE MOCRNM
C     ******************************************************************
C     Read MOC name file
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      PARAMETER (NMOCFT=10)
      CHARACTER*4 CUNIT(NMOCFT)
      CHARACTER*80 LINE
      DIMENSION KUNIT(NMOCFT)
      DATA CUNIT/'CLST','MOC','CRCH','CNCA','CNCB','PRTA','PRTB','VELA',
     1           'VELB','OBS'/
      DATA KUNIT /10*0/
C     ------------------------------------------------------------------
      WRITE(IOUT,*) ' Reading MOC name file:'
      INUNIT=IUREAL(IUNIT(15))
      IFIRST=1
C
C2------READ A LINE; IGNORE BLANK LINES.
20    READ(INUNIT,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 20
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)
      IF(IU.LE.0 .OR. IU.GT.MXFNAM) THEN
         WRITE(IOUT,*) ' File unit out of range:',IU
         CALL RDABRT
      END IF
C
C  CLST must come first
      IF(IFIRST.EQ.1) THEN
         IF(LINE(ITYP1:ITYP2).NE.'CLST') THEN
            WRITE(IOUT,*) ' First file in the MOC name file is type:',
     1            LINE(ITYP1:ITYP2)
            WRITE(IOUT,*) ' The first file must be type: CLST'
            CALL RDABRT
         ELSE
            KUNIT(1)=IU
            IFIRST=0
         END IF
C
C  Check for DATA file type -- can be multiple files
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA') THEN
C
C4------CHECK FOR ALL OTHER VALID MOC FILE TYPES.
      ELSE
         DO 40 I=2,NMOCFT
            IF(LINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
               IF(KUNIT(I).NE.0) THEN
                  WRITE(IOUT,*) ' Duplicate MOC file type:',CUNIT(I)
                  CALL RDABRT
               END IF
               KUNIT(I)=IU
               GO TO 50
            END IF
40       CONTINUE
C  If the file type is invalid, we end up here.
         WRITE(IOUT,*) ' Invalid MOC file type:',LINE(ITYP1:ITYP2)
         CALL RDABRT
50       CONTINUE
      END IF
C  The file type is valid -- temporarily set IFNUSE=-999.
      IFNUSE(IU)=-999
C
C5------DETERMINE FILE NAME AND WRITE ITS NAME.
      IF(IUCASE.EQ.0) THEN
         CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUT,INUNIT)
      ELSE
         CALL URWORD(LINE,LLOC,INAM1,INAM2,1,N,R,IOUT,INUNIT)
      END IF
      WRITE(IOUT,56) LINE(INAM1:INAM2),
     1     LINE(ITYP1:ITYP2),IU
56    FORMAT(1X,/1X,'MOC FILE: ',A,/
     1     1X,'FILE TYPE:',A,'   UNIT',I4)
C
C6------PUT FILE NAME INTO TABLE OF FILE NAMES.
      IF(FILTYP(IU).NE.' ') THEN
         WRITE(IOUT,*) ' ATTEMPT TO OPEN A FILE ON A PREVIOUSLY',
     1        ' DEFINED UNIT'
         WRITE(IOUT,*) ' THE CONFLICT IS ON UNIT',IU
         CALL RDABRT
      END IF
      DO 60 I=1,MXFNAM
      IF(FILNAM(I).EQ.LINE(INAM1:INAM2)) THEN
         WRITE(IOUT,*) ' Duplicate file name:'
         WRITE(IOUT,*) FILNAM(I)
         CALL RDABRT
      END IF
60    CONTINUE
      FILTYP(IU)=LINE(ITYP1:ITYP2)
      FILNAM(IU)=LINE(INAM1:INAM2)
      GO TO 20
C
C7------END OF NAME FILE.
1000  IF(IFIRST.EQ.1) THEN
         WRITE(IOUT,*) ' MOC name file is empty'
         CALL RDABRT
      END IF
      IF(KUNIT(2).EQ.0) THEN
         WRITE(IOUT,*) ' Aborting because there is no MAIN MOC file'
         CALL RDABRT
      END IF
      IUMOCL=KUNIT(1)
      IUMOC=KUNIT(2)
      CALL REALUN(IUMOC)
      OPEN(FILE=FILNAM(IUMOC),UNIT=IUREAL(IUMOC),STATUS='OLD')
      IF(KUNIT(3).NE.0) THEN
         IUCRC=KUNIT(3)
         CALL REALUN(IUCRC)
         OPEN(FILE=FILNAM(IUCRC),UNIT=IUREAL(IUCRC),STATUS='OLD')
      END IF
      IF(KUNIT(10).NE.0) THEN
         IUCOBS=KUNIT(10)
         CALL REALUN(IUCOBS)
         OPEN(FILE=FILNAM(IUCOBS),UNIT=IUREAL(IUCOBS),STATUS='OLD')
      END IF
C
C  Mark Data files as being used by IUMOC -- couldn't be done sooner
C  because IUMOC might not be defined.
      DO 1020 I=1,MXFNAM
         IF(IFNUSE(I).EQ.-999) IFNUSE(I)=IUMOC
1020  CONTINUE
      RETURN
C
      END
      SUBROUTINE MOCRD()
C     ******************************************************************
C     READ AND INITIALIZE DATA FOR MOC
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
      CHARACTER*24 ANAME(9)
      DATA ANAME/'Initial Concentration   ',
     1           'Boundary Inflow Conc.   ',
     2           'Strong Source Flag Array',
     3           'Longitudinal Disp.      ',
     4           'Hor. Transverse Disp.   ',
     5           'Vert. Transverse Disp.  ',
     6           'Retardation Factor      ',
     7           'Thickness               ',
     8           'Porosity                '/
C     ------------------------------------------------------------------
C
C  Read name file -- This defines IUMOC, the unit number for the Main
C  MOC file
      CALL MOCRNM
C
C  Items 1-3
      READ(IUREAL(IUMOC),'(A)') HEDMOC(1)
      READ(IUREAL(IUMOC),'(A)') HEDMOC(2)
      WRITE(IOUT,*) HEDMOC(1)
      WRITE(IOUT,*) HEDMOC(2)
      READ(IUREAL(IUMOC),*) ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2
      WRITE(IOUT,'(A,2I17)') 'Subgrid layer range:',ISLAY1,ISLAY2
      WRITE(IOUT,'(A,2I17)') 'Subgrid row range:',ISROW1,ISROW2
      WRITE(IOUT,'(A,2I17)') 'Subgrid column range:',ISCOL1,ISCOL2
      IF(ISCOL1.LT.1 .OR. ISCOL2.GT.NCOL .OR. ISCOL2.LT.ISCOL1) THEN
         WRITE(IOUT,*) ' Invalid subgrid column range'
         CALL RDABRT
      END IF
      IF(ISROW1.LT.1 .OR. ISROW2.GT.NROW .OR. ISROW2.LT.ISROW1) THEN
         WRITE(IOUT,*) ' Invalid subgrid row range'
         CALL RDABRT
      END IF
      IF(ISLAY1.LT.1 .OR. ISLAY2.GT.NLAY .OR. ISLAY2.LT.ISLAY1) THEN
         WRITE(IOUT,*) ' Invalid subgrid layer range'
         CALL RDABRT
      END IF
      NSCOL=ISCOL2-ISCOL1+1
      NSROW=ISROW2-ISROW1+1
      NSLAY=ISLAY2-ISLAY1+1
      IF(NSCOL.EQ.1 .AND. NSROW.EQ.1 .AND. NSLAY.EQ.1) THEN
         WRITE(IOUT,*) ' Subgrid includes only a single cell'
         CALL RDABRT
      END IF
      NFDIM=0
      IF(NSCOL.GT.1) NFDIM=NFDIM+1
      IF(NSROW.GT.1) NFDIM=NFDIM+1
      IF(NSLAY.GT.1) NFDIM=NFDIM+1
C
C  Check for uniform grid spacing in subgrid
      CALL VALGET('DELR',0,0,IADELR,DUM)
      IF(IADELR.GT.1) THEN
         IF(IARRDA(1,IADELR).EQ.-1) THEN
            LOC=IARRDA(2,IADELR)
            IF(LOC.GT.0) THEN
               D1=X(LOC+ISCOL1-1)
               DO 4 J=ISCOL1,ISCOL2
               IF(X(LOC+J-1).NE.D1) THEN
                  WRITE(IOUT,*)
     1             ' DELR is not uniform withing the MOC subgrid'
                  CALL RDABRT
               END IF
4              CONTINUE
            END IF
         END IF
      END IF
      CALL VALGET('DELC',0,0,IADELC,DUM)
      IF(IADELC.GT.1) THEN
         IF(IARRDA(1,IADELC).EQ.-1) THEN
            LOC=IARRDA(2,IADELC)
            IF(LOC.GT.0) THEN
               D1=X(LOC+ISROW1-1)
               DO 6 I=ISROW1,ISROW2
               IF(X(LOC+I-1).NE.D1) THEN
                  WRITE(IOUT,*)
     1             ' DELC is not uniform withing the MOC subgrid'
                  CALL RDABRT
               END IF
6              CONTINUE
            END IF
         END IF
      END IF
C
C  Items 4-6
      READ(IUREAL(IUMOC),*) NODISP,DECAY,DIFFUS
      WRITE(IOUT,*) ' NODISP=',NODISP
      WRITE(IOUT,*) ' DECAY=',DECAY,'   DIFFUS=',DIFFUS
      CALL VALSAV('DECAY',0,0,DECAY)
      CALL VALSAV('DIFFUS',0,0,DIFFUS)
      READ(IUREAL(IUMOC),*) NPMAX,NPTPND
      WRITE(IOUT,*) ' NPTPND=',NPTPND
      CALL IVLSAV('NPMAX',0,0,NPMAX)
C  Particle coordinates
      IF(NPTPND.GE.0) THEN
         IF((NPTPND.NE.1 .AND. NPTPND.NE.2**NFDIM .AND.
     1      NPTPND.NE.3**NFDIM .AND. NPTPND.NE.4**NFDIM) .OR.
     2         (NFDIM.EQ.3 .AND. NPTPND.EQ.64)) THEN
            IF(NFDIM.EQ.1) THEN
               WRITE(IOUT,*)
     1     ' For 1-D transport, NPTPND must be 1, 2, 3, or 4'
            ELSE IF(NFDIM.EQ.2) THEN
               WRITE(IOUT,*)
     1     ' For 2-D transport, NPTPND must be 1, 4, 9, or 16'
            ELSE
               WRITE(IOUT,*)
     1     ' For 3-D transport, NPTPND must be 1, 8, or 27'
            END IF
            CALL RDABRT
         END IF
      ELSE
         IF(NPTPND.LT.-51) THEN
            WRITE(IOUT,*) ' A maximum of 51 particles can be defined'
            CALL RDABRT
         END IF
         DO 10 I=1,-NPTPND
         READ(IUREAL(IUMOC),*) PNEWL(I),PNEWR(I),PNEWC(I)
         WRITE(IOUT,*) ' PNEWL=',PNEWL(I),'   PNEWR=',PNEWR(I),
     1         '   PNEWC=',PNEWC(I)
10       CONTINUE
      END IF
C
C  Items 7-9
      READ(IUREAL(IUMOC),*) CELDIS,FZERO,INTRPL
      IF(INTRPL.NE.2) INTRPL=1
      WRITE(IOUT,*) ' CELDIS=',CELDIS,'   FZERO=',FZERO,
     1           '   INTRPL=',INTRPL
      CALL VALSAV('CELDIS',0,0,CELDIS)
      CALL VALSAV('FZERO',0,0,FZERO)
      CALL IVLSAV('INTRPL',0,0,INTRPL)
      READ(IUREAL(IUMOC),*) NPNTCL,ICONFM,NPNTVL,IVELFM,NPNTDL,IDSPFM,
     1                 NPNTPL
      WRITE(IOUT,*) ' NPNTCL=',NPNTCL,'   ICONFM=',ICONFM,'   NPNTVL=',
     1              NPNTVL
      WRITE(IOUT,*) ' IVELFM=',IVELFM,'   NPNTDL=',NPNTDL,'   IDSPFM=',
     1              IDSPFM
      WRITE(IOUT,*) ' NPNTPL=',NPNTPL
      CALL IVLSAV('NPNTCL',0,0,NPNTCL)
      CALL IVLSAV('ICONFM',0,0,ICONFM)
      CALL IVLSAV('NPNTVL',0,0,NPNTVL)
      CALL IVLSAV('IVELFM',0,0,IVELFM)
      CALL IVLSAV('NPNTDL',0,0,NPNTDL)
      CALL IVLSAV('IDSPFM',0,0,IDSPFM)
      CALL IVLSAV('NPNTPL',0,0,NPNTPL)
      READ(IUREAL(IUMOC),*) CNOFLO
      CALL VALSAV('CNOFLO',0,0,CNOFLO)
      WRITE(IOUT,*) ' CNOFLO=',CNOFLO
C
C  Initial concentration
      DO 20 K=1,NSLAY
      KK=K
      CALL ARRMAK('CINT',KK,0,NSCOL,NSROW)
      CALL U2DREL(ANAME(1),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
20    CONTINUE
C
C  CINFL
      ICINFL=0
      IF(ISCOL1.GT.1 .OR. ISCOL2.LT.NCOL .OR.
     1         ISROW1.GT.1 .OR. ISROW2.LT.NROW) ICINFL=ICINFL+NSLAY
      IF(ISLAY1.GT.1) ICINFL=ICINFL+1
      IF(ISLAY2.LT.NLAY) ICINFL=ICINFL+1
      IF(ICINFL.GT.0) THEN
         CALL ARRMAK('CINFL',0,0,ICINFL,1)
         CALL U1DREL(ANAME(2),ICINFL,IUMOC,NARRAY)
      END IF
C
C  Fixed head zones
      READ(IUREAL(IUMOC),*) NZONES
      WRITE(IOUT,*) ' NZONES=',NZONES
      IF(NZONES.LT.0) NZONES=0
      CALL IVLSAV('NZONES',0,0,NZONES)
      IF(NZONES.GT.MXCZON) THEN
         WRITE(IOUT,*) ' Stopping because NZONES>',MXCZON
         CALL RDABRT
      END IF
      IF(NZONES.GT.0) THEN
         WRITE(IOUT,'(A)') '     IZONE      ZONCON'
         DO 30 I=1,NZONES
         READ(IUREAL(IUMOC),*) IZONE(I),ZONCON(I)
         WRITE(IOUT,'(I10,1PE12.3)') IZONE(I),ZONCON(I)
30       CONTINUE
      END IF
C
C  Strong source flag array
      DO 40 K=1,NSLAY
      KK=K
      CALL ARRMAK('IGENPT',KK,0,NSCOL,NSROW)
      CALL U2DINT(ANAME(3),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
40    CONTINUE
C
C  Dispersivities
      IF(NODISP.EQ.0) THEN
         CALL ARRMAK('ALONG',0,0,NSLAY,1)
         CALL U1DREL(ANAME(4),NSLAY,IUMOC,NARRAY)
         CALL ARRMAK('ATRANH',0,0,NSLAY,1)
         CALL U1DREL(ANAME(5),NSLAY,IUMOC,NARRAY)
         CALL ARRMAK('ATRANV',0,0,NSLAY,1)
         CALL U1DREL(ANAME(6),NSLAY,IUMOC,NARRAY)
      END IF
C
C  Retardation factor
      CALL ARRMAK('RF',0,0,NSLAY,1)
      CALL U1DREL(ANAME(7),NSLAY,IUMOC,NARRAY)
C
C  Thickness and porosity
      DO 60 K=1,NSLAY
      KK=K
      CALL ARRMAK('THCK',KK,0,NSCOL,NSROW)
      CALL U2DREL(ANAME(8),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
      CALL ARRMAK('PORMOC',KK,0,NSCOL,NSROW)
      CALL U2DREL(ANAME(9),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
60    CONTINUE
C
      CLOSE(IUREAL(IUMOC))
C
C
C  MOC Recharge concentration file
      IF(IUCRC.GT.0) CALL MOCRRC
C
C  MOC Observation locations file
      IF(IUCOBS.GT.0) CALL MOCROB
C
      RETURN
      END
      SUBROUTINE MOCED
C     ******************************************************************
C     Edit MOC data
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
      CHARACTER*78 RCHFIL
      DIMENSION ISUBG(6)
      CHARACTER*78 LABEL
C     ------------------------------------------------------------------
C
C  Set IUNIT and IUMOC if not already set
      IF(IUNIT(15).EQ.0) THEN
         MODOUT=1
         CALL FINDUN(25,IU,'CNC')
         FILTYP(IU)='CONC'
         IUNIT(15)=IU
         IUNIT2(15)=0
         CALL FINDUN(50,IU,'MOC')
         IUMOC=IU
         CALL FINDUN(51,IU,'LSM')
         FILTYP(IU)='CLST'
         IUMOCL=IU
         IFNUSE(IU)=IUMOC
         IUCRC=0
         NODISP=1
         NPTPND=1
         HEDMOC(1)=' '
         HEDMOC(2)=' '
C  Define the subgrid 
         IF(NSCOL.NE.0) THEN
C  Subgrid already defined
            ISUBG(1)=ISCOL1
            ISUBG(2)=ISCOL2
            ISUBG(3)=ISROW1
            ISUBG(4)=ISROW2
            ISUBG(5)=ISLAY1
            ISUBG(6)=ISLAY2
            CALL PMXTXI(MESSFL,310,7,50,1,0,6,ISUBG)
         ELSE
C  Get new subgrid limits
            ISUBG(1)=1
            ISUBG(2)=NCOL
            ISUBG(3)=1
            ISUBG(4)=NROW
            ISUBG(5)=1
            ISUBG(6)=NLAY
10          CALL Q1INIT(MESSFL,310,6)
            CALL QSETI(6,ISUBG)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 10
            CALL QGETI(6,ISUBG)
            IF(ISUBG(2).GT.NCOL) ISUBG(2)=NCOL
            IF(ISUBG(4).GT.NROW) ISUBG(4)=NROW
            IF(ISUBG(6).GT.NLAY) ISUBG(6)=NLAY
            IF(ISUBG(1).GT.ISUBG(2) .OR. ISUBG(3).GT.ISUBG(4) .OR.
     1                      ISUBG(5).GT.ISUBG(6)) THEN
               CALL PRNTXT(MESSFL,310,5)
               GO TO 10
            END IF
            ISCOL1=ISUBG(1)
            ISCOL2=ISUBG(2)
            ISROW1=ISUBG(3)
            ISROW2=ISUBG(4)
            ISLAY1=ISUBG(5)
            ISLAY2=ISUBG(6)
         END IF
C
C  Check for uniform grid spacing in subgrid
         CALL VALGET('DELR',0,0,IADELR,DUM)
         IF(IADELR.GT.1) THEN
            IF(IARRDA(1,IADELR).EQ.-1) THEN
               LOC=IARRDA(2,IADELR)
               IF(LOC.GT.0) THEN
                  D1=X(LOC+ISCOL1-1)
                  IERR=0
                  DO 4 J=ISCOL1,ISCOL2
                  IF(X(LOC+J-1).NE.D1) IERR=1
4                 CONTINUE
                  IF(IERR.NE.0) CALL PRNTXT(MESSFL,310,3)
               END IF
            END IF
         END IF
         CALL VALGET('DELC',0,0,IADELC,DUM)
         IF(IADELC.GT.1) THEN
            IF(IARRDA(1,IADELC).EQ.-1) THEN
               LOC=IARRDA(2,IADELC)
               IF(LOC.GT.0) THEN
                  D1=X(LOC+ISROW1-1)
                  IERR=0
                  DO 6 I=ISROW1,ISROW2
                  IF(X(LOC+I-1).NE.D1) IERR=1
6                 CONTINUE
                  IF(IERR.NE.0) CALL PRNTXT(MESSFL,310,4)
               END IF
            END IF
         END IF
         NSCOL=ISCOL2-ISCOL1+1
         NSROW=ISROW2-ISROW1+1
         NSLAY=ISLAY2-ISLAY1+1
         ICINFL=0
         IF(ISCOL1.GT.1 .OR. ISCOL2.LT.NCOL .OR.
     1         ISROW1.GT.1 .OR. ISROW2.LT.NROW) ICINFL=ICINFL+NSLAY
         IF(ISLAY1.GT.1) ICINFL=ICINFL+1
         IF(ISLAY2.LT.NLAY) ICINFL=ICINFL+1
      END IF
C
C  Main MOC menu
      IOPT=1
20    CALL QRESP(MESSFL,310,1,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  Miscellaneous
C   -- initialize screen
21       CALL Q1INIT(MESSFL,310,8)
C  Define default values
         CALL QSTCTF(1,78,HEDMOC(1))
         CALL QSTCTF(2,78,HEDMOC(2))
         CALL VALGET('CNOFLO',0,0,ITYPE,CNOFLO)
         IF(ITYPE.NE.0) CNOFLO=999.99
         CALL QSETRB(1,1,CNOFLO)
         CALL VALGET('DECAY',0,0,ITYPE,DECAY)
         IF(ITYPE.NE.0) DECAY=0.
         CALL QSETRB(1,2,DECAY)
         CALL VALGET('DIFFUS',0,0,ITYPE,DIFFUS)
         IF(ITYPE.NE.0) DIFFUS=0.
         CALL QSETRB(1,3,DIFFUS)
C  Activate user input
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 21
C  Save returned values
         CALL QGTCTF(1,78,HEDMOC(1))
         CALL QGTCTF(2,78,HEDMOC(2))
         CALL QGETRB(1,1,CNOFLO)
         CALL VALSAV('CNOFLO',0,0,CNOFLO)
         CALL QGETRB(1,2,DECAY)
         CALL VALSAV('DECAY',0,0,DECAY)
         CALL QGETRB(1,3,DIFFUS)
         CALL VALSAV('DIFFUS',0,0,DIFFUS)
C
      ELSE IF(IOPT.EQ.2) THEN
C  Edit particle information
         NFDIM=0
         IF(NSCOL.GT.1) NFDIM=NFDIM+1
         IF(NSROW.GT.1) NFDIM=NFDIM+1
         IF(NSLAY.GT.1) NFDIM=NFDIM+1
210      CALL Q1INIT(MESSFL,310,11)
         CALL IVLGET('NPMAX',0,0,ITYPE,NPMAX)
         IF(ITYPE.NE.0) NPMAX=0
         CALL QSETIB(1,1,NPMAX)
         CALL QSETIB(1,2,NPTPND)
         CALL VALGET('CELDIS',0,0,ITYPE,CELDIS)
         IF(ITYPE.NE.0) CELDIS=0.5
         CALL QSETRB(1,1,CELDIS)
         CALL VALGET('FZERO',0,0,ITYPE,FZERO)
         IF(ITYPE.NE.0) FZERO=.05
         CALL QSETRB(1,2,FZERO)
         CALL IVLGET('INTRPL',0,0,ITYPE,INTRPL)
         IF(ITYPE.NE.0) INTRPL=1
         CALL QSETOP(1,1,1,1,INTRPL)
C
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 210
C
         CALL QGETIB(1,1,NPMAX)
         CALL IVLSAV('NPMAX',0,0,NPMAX)
         CALL QGETIB(1,2,NPTPND)
         CALL QGETRB(1,1,CELDIS)
         CALL VALSAV('CELDIS',0,0,CELDIS)
         CALL QGETRB(1,2,FZERO)
         CALL VALSAV('FZERO',0,0,FZERO)
         CALL QGETOP(1,INTRPL)
         CALL IVLSAV('INTRPL',0,0,INTRPL)
         IF(NPTPND.GE.0) THEN
            IF((NPTPND.NE.1 .AND. NPTPND.NE.2**NFDIM .AND.
     1         NPTPND.NE.3**NFDIM .AND. NPTPND.NE.4**NFDIM) .OR.
     2                (NFDIM.EQ.3 .AND. NPTPND.EQ.64)) THEN
               IF(NFDIM.EQ.1) THEN
                CTEXT(1)='For a 1-dimensional transport problem,'//
     1            ' NPTPND must be 1, 2, 3, or 4'
               ELSE IF(NFDIM.EQ.2) THEN
                CTEXT(1)='For a 1-dimensional transport problem,'//
     1            ' NPTPND must be 1, 4, 9, or 16'
               ELSE
                CTEXT(1)='For a 3-dimensional transport problem,'//
     1            ' NPTPND must be 1, 8, or 27'
               END IF
               CALL DSPTXT(MESSFL,310,13,CTEXT,2,78)
               GO TO 210
            END IF
         ELSE
220         CALL Q2INIT(MESSFL,310,12)
            N=-NPTPND
            CALL Q2STRB(1,1,N,PNEWL)
            CALL Q2STRB(1,2,N,PNEWR)
            CALL Q2STRB(1,3,N,PNEWC)
            CALL Q2EDIT(N,IRET)
            IF(IRET.EQ.-1) GO TO 220
            CALL Q2GTRB(1,1,N,PNEWL)
            CALL Q2GTRB(1,2,N,PNEWR)
            CALL Q2GTRB(1,3,N,PNEWC)
         END IF
C
      ELSE IF(IOPT.EQ.3) THEN
C  Edit MOC output control data
         CALL MOCOC
C
      ELSE IF(IOPT.EQ.4) THEN
C  Edit constant-head concentration (ZONCON)
410      CALL Q1INIT(MESSFL,310,14)
         CALL IVLGET('NZONES',0,0,ITYPE,NZONES)
         IF(ITYPE.NE.0) NZONES=0
         CALL QSETIB(1,1,NZONES)
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 410
         CALL QGETIB(1,1,NZONES)
         IF(NZONES.GT.MXCZON) THEN
            CALL PMXTXI(MESSFL,310,16,50,1,0,1,MXCZON)
            GO TO 410
         END IF
         CALL IVLSAV('NZONES',0,0,NZONES)
         IF(NZONES.GT.0) THEN
430         CALL Q2INIT(MESSFL,310,15)
            CALL Q2STIB(1,1,NZONES,IZONE)
            CALL Q2STRB(1,1,NZONES,ZONCON)
            CALL Q2EDIT(NZONES,IRET)
            IF(IRET.EQ.-1) GO TO 430
            CALL Q2GTIB(1,1,NZONES,IZONE)
            CALL Q2GTRB(1,1,NZONES,ZONCON)
         END IF
C
      ELSE IF(IOPT.EQ.5) THEN
C  Edit retardation factor (RF)
         CALL U2DIN('Retardation Factor (RF)','RF',0,0,-1,NSLAY,IUMOC)
C  Use AIDE spreadsheet if this is an internal array.
         CALL VALGET('RF',0,0,IAR,RF)
         IF(IARRDA(1,IAR).EQ.-1) THEN
            LOC=IARRDA(2,IAR)
C  Build screen labels
510         LABEL= 'Retardation Factor (RF) for transport subgrid'
            CALL ZBLDWR(78,LABEL,1,-1,ISTAT)
            LABEL=' '
            CALL ZBLDWR(78,LABEL,0,-1,ISTAT)
            LABEL='Flow model  Transport          Retardation'
            CALL ZBLDWR(78,LABEL,0,-1,ISTAT)
            LABEL='  Layer     Subgrid Layer         Factor'
            CALL ZBLDWR(78,LABEL,0,-1,ISTAT)
            CALL ZMNSST
            CALL LAYARR(LOC,IRET,'RF')
            IF(IRET.EQ.-1) GO TO 510
         END IF
C
      ELSE IF(IOPT.EQ.6) THEN
C  Edit initial concentration (CINT)
         ILAY=1
620      IF(NSLAY.GT.1) CALL SGLAIN('Initial Concentration (CINT)',ILAY)
         IF(ILAY.GT.0) THEN
            CALL U2DIN('Initial Conc. in subgrid (CINT)','CINT',
     1                    ILAY,0,NSCOL,NSROW,IUMOC)
C  Now see if another layer is desired -- set default to layer+1
            ILAY=ILAY+1
            IF(ILAY.GT.NSLAY) ILAY=1
            IF(NSLAY.GT.1) GO TO 620
         END IF
C
      ELSE IF(IOPT.EQ.7) THEN
C  Edit IGENPT
         ILAY=1
720      IF(NSLAY.GT.1) CALL SGLAIN('Strong source flags (IGENPT)',ILAY)
         IF(ILAY.GT.0) THEN
            CALL U2DIN('IGENPT for subgrid',
     1               'IGENPT',ILAY,0,NSCOL,NSROW,IUMOC)
C  Now see if another layer is desired -- set default to layer+1
            ILAY=ILAY+1
            IF(ILAY.GT.NSLAY) ILAY=1
            IF(NSLAY.GT.1) GO TO 720
         END IF
C
      ELSE IF(IOPT.EQ.8) THEN
C  Edit Porosity
         ILAY=1
820      IF(NSLAY.GT.1) CALL SGLAIN('Porosity (POR)',ILAY)
         IF(ILAY.GT.0) THEN
            CALL U2DIN('Porosity for subgrid (POR)','PORMOC',
     1                    ILAY,0,NSCOL,NSROW,IUMOC)
C  Now see if another layer is desired -- set default to layer+1
            ILAY=ILAY+1
            IF(ILAY.GT.NSLAY) ILAY=1
            IF(NSLAY.GT.1) GO TO 820
         END IF
C
      ELSE IF(IOPT.EQ.9) THEN
C  Edit Thickness
         ILAY=1
920      IF(NSLAY.GT.1) CALL SGLAIN('Thickness (THCK)',ILAY)
         IF(ILAY.GT.0) THEN
            CALL U2DIN('Thickness for subgrid (THCK)','THCK',
     1                    ILAY,0,NSCOL,NSROW,IUMOC)
C  Now see if another layer is desired -- set default to layer+1
            ILAY=ILAY+1
            IF(ILAY.GT.NSLAY) ILAY=1
            IF(NSLAY.GT.1) GO TO 920
         END IF
C
      ELSE IF(IOPT.EQ.10) THEN
C  Edit dispersivity
         IND=NODISP+1
         CALL QRESP(MESSFL,310,26,IND)
         NODISP=IND-1
         IF(NODISP.EQ.0) THEN
            CALL U2DIN('Longitudinal Dispersivity (ALONG)',
     1          'ALONG',0,0,1,NSLAY,IUMOC)
            CALL U2DIN('Horizontal Trans. Dispersivity (ATRANH)',
     1          'ATRANH',0,0,1,NSLAY,IUMOC)
            CALL U2DIN('Vertical Trans. Dispersivity (ATRANV)',
     1          'ATRANV',0,0,1,NSLAY,IUMOC)
         END IF
C
      ELSE IF(IOPT.EQ.11) THEN
C  Edit Boundary Concentration (CINFL)
         IF(ICINFL.GT.0) THEN
            CALL U2DIN('CINFL','CINFL',0,0,-1,ICINFL,IUMOC)
C  Use AIDE spreadsheet if this is an internal array.
            CALL VALGET('CINFL',0,0,IAR,CINFL)
            IF(IARRDA(1,IAR).EQ.-1) THEN
               LOC=IARRDA(2,IAR)
C  Build screen labels
950            LABEL= 'Subgrid boundary concentration (CINFL)'
               CALL ZBLDWR(78,LABEL,1,-1,ISTAT)
               LABEL=' '
               CALL ZBLDWR(78,LABEL,0,-1,ISTAT)
               LABEL='Flow model  Transport          Subgrid boundary'
               CALL ZBLDWR(78,LABEL,0,-1,ISTAT)
               LABEL='  Layer     Subgrid Layer        Concentration'
               CALL ZBLDWR(78,LABEL,0,-1,ISTAT)
               CALL ZMNSST
               CALL LAYARR(LOC,IRET,'CINFL')
               IF(IRET.EQ.-1) GO TO 950
            END IF
         ELSE
C  CINFL not required
            CALL PRNTXT(MESSFL,310,29)
         END IF
C
      ELSE IF(IOPT.EQ.12) THEN
C  Edit Recharge
         CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
         IF(ITYPE.NE.0) NRCHOP=1
         IF(IUNIT(8).GT.0 .AND.
     1       ( (NRCHOP.EQ.1 .AND. ISLAY1.EQ.1) .OR. NRCHOP.NE.1) ) THEN
            IF(IUCASE.NE.0) RCHFIL=DSNAME(1:NDSNAM)//'.CRC'
            IF(IUCASE.EQ.0) RCHFIL=DSNAME(1:NDSNAM)//'.crc'
960         IF(RCHFIL.EQ.' ') THEN
               CALL PRNTXT(MESSFL,310,25)
               GO TO 960
            END IF
            CALL FNDUN2(RCHFIL,IU,'CRCH',IUMOC)
            IF(IU.LE.0) THEN
962            CALL Q1INIT(MESSFL,310,2)
               CALL QSETCT(1,78,78,RCHFIL)
               CALL Q1EDIT(IRET)
               IF(IRET.EQ.-1) GO TO 962
               CALL QGETCT(1,78,78,RCHFIL)
               IF(IUCASE.NE.0) CALL USTRLC(RCHFIL,78)
               GO TO 960
            ELSE
               IUCRC=IU
            END IF
C  Edit Recharge arrays -- get stress period
            KPER=1
990         CALL UPERIN('Recharge Concentration Data',KPER)
C  If PREV AIDE option was selected, done with recharge concentration
            IF(KPER.EQ.0) GO TO 1000
C  Stress period is accepted
C  Edit CRECH array
            CALL U2DIN('Recharge Conc. for subgrid (CRECH)','CRECH',
     1            0,KPER,NSCOL,NSROW,IUCRC)
C  Get another stress period if there's more than one.
            KPER=KPER+1
            IF(KPER.GT.NPER) KPER=1
            IF(NPER.GT.1) GO TO 990
         ELSE
C  Recharge not required
            CALL PRNTXT(MESSFL,310,30)
         END IF
C  
C
      ELSE IF(IOPT.EQ.13) THEN
C  Undefined
         CALL MOCSV(IUNDEF,-1)
C
      ELSE
C  End of MOC data input
         CALL MOCSV(IUNDEF,1)
         RETURN
      END IF
C
1000  IOPT=IOPT+1
      GO TO 20
C
      END
      SUBROUTINE MOCSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR MOC
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C     ------------------------------------------------------------------
      IF(IUNIT(15).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      NMISS=0
C
      MODSAV=MODOUT
      MODOUT=1
C  Unmark all MOC files except the special output files.
      DO 10 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUMOC .AND.
     1      FILTYP(I).NE.'CNCA' .AND. FILTYP(I).NE.'CNCB' .AND.
     2      FILTYP(I).NE.'VELA' .AND. FILTYP(I).NE.'VELB' .AND.
     3      FILTYP(I).NE.'PRTA' .AND. FILTYP(I).NE.'PRTB') IFNUSE(I)=0
10    CONTINUE
      IFNUSE(IUMOCL)=IUMOC
      IFNUSE(IUMOC)=IUMOC
C
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.MOC',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUMOC),UNIT=IFIL)
C
C  Items 1-5
      IF(IWRFLG.GT.0) THEN
         WRITE(IFIL,'(A)') HEDMOC(1)
         WRITE(IFIL,'(A)') HEDMOC(2)
         WRITE(IFIL,'(6I6,A)') ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,
     1       ISCOL2,'  ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2'
         CALL VALGET('DECAY',0,0,ITYPE,DECAY)
         IF(ITYPE.NE.0) DECAY=0.
         CALL VALGET('DIFFUS',0,0,ITYPE,DIFFUS)
         IF(ITYPE.NE.0) DIFFUS=0.
         WRITE(IFIL,'(I6,1P,2E12.3,A)') NODISP,DECAY,
     1         DIFFUS,'  NODISP,DECAY,DIFFUS'
         CALL IVLGET('NPMAX',0,0,ITYPE,NPMAX)
         IF(ITYPE.NE.0) NPMAX=0
         WRITE(IFIL,'(2I6,A)') NPMAX,NPTPND,
     1                      '  NPMAX,NPTPND'
      END IF
C  Particle coordinates
      IF(IWRFLG.GT.0 .AND. NPTPND.LT.0) THEN
         DO 15 I=1,-NPTPND
         WRITE(IFIL,*) PNEWL(I),PNEWR(I),PNEWC(I)
15       CONTINUE
      END IF
C
C  Items 7-9
      IF(IWRFLG.GT.0) THEN
         CALL VALGET('CELDIS',0,0,ITYPE,CELDIS)
         IF(ITYPE.NE.0) CELDIS=0.1
         CALL VALGET('FZERO',0,0,ITYPE,FZERO)
         IF(ITYPE.NE.0) FZERO=0.05
         CALL IVLGET('INTRPL',0,0,ITYPE,INTRPL)
         IF(ITYPE.NE.0) INTRPL=1
         WRITE(IFIL,'(1P,2E12.3,I6,A)') CELDIS,FZERO,INTRPL,
     1                               '  CELDIS,FZERO,INTRPL'
         CALL IVLGET('NPNTCL',0,0,ITYPE,NPNTCL)
         IF(ITYPE.NE.0) NPNTCL=0
         CALL IVLGET('ICONFM',0,0,ITYPE,ICONFM)
         IF(ITYPE.NE.0) ICONFM=0
         CALL IVLGET('NPNTVL',0,0,ITYPE,NPNTVL)
         IF(ITYPE.NE.0) NPNTVL=0
         CALL IVLGET('IVELFM',0,0,ITYPE,IVELFM)
         IF(ITYPE.NE.0) IVELFM=0
         CALL IVLGET('NPNTDL',0,0,ITYPE,NPNTDL)
         IF(ITYPE.NE.0) NPNTDL=0
         CALL IVLGET('IDSPFM',0,0,ITYPE,IDSPFM)
         IF(ITYPE.NE.0) IDSPFM=0
         CALL IVLGET('NPNTPL',0,0,ITYPE,NPNTPL)
         IF(ITYPE.NE.0) NPNTPL=0
         WRITE(IFIL,'(7I6,A)')
     1     NPNTCL,ICONFM,NPNTVL,IVELFM,NPNTDL,IDSPFM,NPNTPL,
     2  '  NPNTCL,ICONFM,NPNVTL,IVELFM,NPNTDL,IDSPFM,NPNTPL'
         CALL VALGET('CNOFLO',0,0,ITYPE,CNOFLO)
         IF(ITYPE.NE.0) CNOFLO=999.99
         IF(ABS(CNOFLO).LE.999999. .AND. ABS(CNOFLO).GE.100.) THEN
            WRITE(IFIL,'(F10.2,A)') CNOFLO,'  CNOFLO'
         ELSE
            WRITE(IFIL,'(1P,E10.3,A)') CNOFLO,'  CNOFLO'
         END IF
      END IF
C
C  Initial concentration
      DO 20 K=1,NSLAY
      KK=K
      CALL U2DRSV('CINT',KK,0,IUNDEF,IFIL,IUMOC,'CINT',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I10)') 'Initial conc. (CINT)',KK
      END IF
20    CONTINUE
C
C  CINFL
      IF(ICINFL.GT.0) THEN
         CALL U1DRSV('CINFL',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'Grd.bnd.conc.(CINFL)'
         END IF
      END IF
C
C  Fixed head zones
      IF(IWRFLG.GT.0) THEN
         NZONES=0
            DO 29 I=1,MXCZON
            IF(IZONE(I).NE.0) NZONES=NZONES+1
29          CONTINUE
         WRITE(IFIL,'(I6,A)') NZONES,'  NZONES'
         IF(NZONES.GT.0) THEN
            DO 30 I=1,MXCZON
            IF(IZONE(I).NE.0) WRITE(IFIL,'(I6,1P,E12.3)')
     1                       IZONE(I),ZONCON(I)
30          CONTINUE
         END IF
      END IF
C
C  Strong source flag array
      DO 40 K=1,NSLAY
      KK=K
      CALL U2DISV('IGENPT',KK,0,IUNDEF,IFIL,IUMOC)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I10)') 'Strong flags(IGENPT)',KK
      END IF
40    CONTINUE
C
C  Dispersivities
      IF(NODISP.EQ.0) THEN
         CALL U1DRSV('ALONG',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'Long. disp. (ALONG) '
         END IF
         CALL U1DRSV('ATRANH',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'H.tran.disp.(ATRANH)'
         END IF
         CALL U1DRSV('ATRANV',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'V.tran.disp.(ATRANV)'
         END IF
      END IF
C
C  Retardation factor
      CALL U1DRSV('RF',IUNDEF,IFIL,IUMOC)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,10X)') 'Retard. Fact. (RF)  '
      END IF
C
C  Thickness and porosity
      DO 60 K=1,NSLAY
      KK=K
      CALL U2DRSV('THCK',KK,0,IUNDEF,IFIL,IUMOC,'THCK',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I10)') 'Layer thick. (THCK) ',KK
      END IF
      CALL U2DRSV('PORMOC',KK,0,IUNDEF,IFIL,IUMOC,'PORMOC',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I10)') 'Porosity (POR)      ',KK
      END IF
60    CONTINUE
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
C
C  MOC Recharge concentration file
      CALL MOCWRC(IUNDEF,IWRFLG)
C
C  Check if concentration data for auxiliary point stress packages has been
C  entered.
      IF(IUNIT(2).GT.0) THEN
         IF(WELAUX(2).NE.'CONC' .AND. WELAUX(2).NE.'CONCENTRATION' .AND.
     1      WELAUX(3).NE.'CONC' .AND. WELAUX(3).NE.'CONCENTRATION') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'Well concentration (WEL Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(4).GT.0) THEN
         IF(RIVAUX(2).NE.'CONC' .AND. RIVAUX(2).NE.'CONCENTRATION' .AND.
     1      RIVAUX(3).NE.'CONC' .AND. RIVAUX(3).NE.'CONCENTRATION') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'River concentration (RIV Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(7).GT.0) THEN
         IF(GHBAUX(2).NE.'CONC' .AND. GHBAUX(2).NE.'CONCENTRATION' .AND.
     1      GHBAUX(3).NE.'CONC' .AND. GHBAUX(3).NE.'CONCENTRATION') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'GHB concentration (GHB Package)'
            END IF
         END IF
      END IF
C
C  Display undefined data
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.0) THEN
            CALL DSPTXT(MESSFL,310,9,CTEXT,NMISS,40)
            IUNDEF=1
         ELSE
            CALL PRNTXT(MESSFL,310,10)
         END IF
      END IF
C
C  MOC Observation locations file
      CALL MOCWOB(IWRFLG)
C
C  MOC Name file
      IF(IWRFLG.GT.1) CALL MOCWNM
C
      CALL FNMRMV
      MODOUT=MODSAV
      RETURN
      END
      SUBROUTINE MOCWNM
C     ******************************************************************
C     Write the MOC name file
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      IF(IUREAL(IUNIT(15)).EQ.0) CALL REALUN(IUNIT(15))
      OPEN(UNIT=IUMISC,FILE=FILNAM(IUNIT(15)))
      IF(IUREAL(IUMOCL).EQ.0) CALL REALUN(IUMOCL)
      J=LENSTR(80,FILNAM(IUMOCL))
      WRITE(IUMISC,25) FILTYP(IUMOCL),IUREAL(IUMOCL),FILNAM(IUMOCL)(1:J)
25    FORMAT(A,I5,1X,A)
C
      DO 200 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUMOC .AND. I.NE.IUMOCL) THEN
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         J=LENSTR(80,FILNAM(I))
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
200   CONTINUE
C
      RETURN
      END
      SUBROUTINE MOCWRC(IUNDEF,IWRFLG)
C     ******************************************************************
C     WRITE recharge concentrations
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C     ------------------------------------------------------------------
C  Rechrage concentration is required only if RCH is on.
      IF(IUNIT(8).LE.0) THEN
         IUCRC=0
         RETURN
      END IF
C
C  Recharge concentration is only required if recharge is applied
C  to subgrid
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
      IF(ITYPE.NE.0) NRCHOP=1
      IF(NRCHOP.EQ.1 .AND. ISLAY1.NE.1) THEN
         IUCRC=0
         RETURN
      END IF
C
C  Recharge concentration is required -- check if a file has been defined
      IF(IUCRC.EQ.0) THEN
         IUNDEF=1
         IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A)') 'Rech. conc. (CRECH)'
         END IF
         RETURN
      END IF
C
      IFNUSE(IUCRC)=IUMOC
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.CRC',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUCRC),UNIT=IFIL)
C
      DO 100 KPER=1,NPER
      INCRCH=1
      CALL VALGET('CRECH',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INCRCH=-1
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(I10,A)')
     1           INCRCH,'  INCRCH'
      IF(INCRCH.GT.0) THEN
C  Note that if "old" output were being used, the wrong unit number (IUMOC)
C  would be written on the control record for an internal file.  But because
C  new control records are always written for MOC3D, "INTERNAL" is written,
C  which is OK.
         CALL U2DRSV('CRECH',0,KPER,IUNDEF,IFIL,IUMOC,'CRECH',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I20)') 'Rech. conc. (CRECH) ',KPER
            END IF
         END IF
      END IF
100   CONTINUE
C
      IF(IFIL.GT.0) CLOSE(UNIT=IFIL)
      RETURN
      END
      SUBROUTINE MOCWOB(IWRFLG)
C     ******************************************************************
C     WRITE observation locations
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C     ------------------------------------------------------------------
C
      NUMOBS=0
      DO 10 I=1,MXCOB
      IF(ICOB(1,I).GT.0 .AND. ICOB(2,I).GT.0 .AND. ICOB(3,I).GT.0) THEN
         NUMOBS=NUMOBS+1
      END IF
10    CONTINUE
C
      IF(NUMOBS.GT.0 .AND. IUCOBS.GT.0) THEN
         IFNUSE(IUCOBS)=IUMOC
         IF(IWRFLG.GT.1) OPEN(UNIT=IUMISC,FILE=FILNAM(IUCOBS))
         CALL IVLGET('IOBSFL',0,0,ITYPE,IOB)
         IF(ITYPE.NE.0) IOB=0
         IOBSFL=IOB
         IF(IOB.GT.0) IOBSFL=1
         IF(IWRFLG.GT.1)
     1      WRITE(IUMISC,'(2I6,A)') NUMOBS,IOBSFL,'  NUMOBS,IOBSFL'
         IF(IOBSFL.GT.0) THEN
            IFIRST=1
            DO 20 I=1,MXCOB
            IF(ICOB(1,I).GT.0 .AND. ICOB(2,I).GT.0 .AND. ICOB(3,I).GT.0)
     1                       THEN
               IF(IFIRST.EQ.1) THEN
                  IFIRST=0
                  IF(IUREAL(IOB).EQ.0) CALL REALUN(IOB)
                  IF(IWRFLG.GT.1) WRITE(IUMISC,'(4I6)')
     1                             (ICOB(J,I),J=1,3),IUREAL(IOB)
                  IFNUSE(IOB)=IUMOC
               ELSE
                  IF(IWRFLG.GT.1) WRITE(IUMISC,'(4I6)')
     1                             (ICOB(J,I),J=1,3),0
               END IF
            END IF
20          CONTINUE
         ELSE
            DO 30 I=1,MXCOB
            IF(ICOB(1,I).GT.0 .AND. ICOB(2,I).GT.0 .AND. ICOB(3,I).GT.0)
     1                       THEN
            IF(IUREAL(ICOBFL(I)).EQ.0) CALL REALUN(ICOBFL(I))
            IF(IWRFLG.GT.1)
     1      WRITE(IUMISC,'(4I6,A)') (ICOB(J,I),J=1,3),IUREAL(ICOBFL(I))
            IFNUSE(ICOBFL(I))=IUMOC
            END IF
30          CONTINUE
         END IF
         IF(IWRFLG.GT.1) CLOSE(UNIT=IUMISC)
      ELSE
         IUCOBS=0
      END IF
C
      RETURN
      END
      SUBROUTINE SGLAIN(LABEL,ILAY)
C     ******************************************************************
C     Prompt user to enter a layer number
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*(*) LABEL
      CHARACTER*78 CLINE
C     ------------------------------------------------------------------
C
C  Prepare a label for layer number screen
20    WRITE(CLINE,'(A)') LABEL
      CALL ZBLDWR(78,CLINE,1,-1,ISTAT)
      CALL ZMNSST
C  Initialize layer number screen
      CALL Q1INIT(MESSFL,310,28)
C  Set default layer
      CALL QSETI(1,ILAY)
C  Turn on "previous screen" option
      CALL ZSTCMA(4,1)
C  Activate user input
      CALL Q1EDIT(IRET)
C  Turn off "previous screen" option
      CALL ZSTCMA(4,0)
      IF(IRET.EQ.-1) GO TO 20
      IF(IRET.EQ.1) THEN
C  Layer number is accepted -- get number and check for validity
         CALL QGETI(1,ILAY)
         IF(ILAY.GT.NSLAY) THEN
C  Invalid layer -- notify user and try again
            CALL PMXTXI(MESSFL,310,27,2,1,0,1,NSLAY)
            ILAY=1
            GO TO 20
         END IF
      ELSE
C  No layer number -- go to previous menu
         ILAY=0
      END IF
C
C  Return with valid layer number or 0 to indicate previous screen
      RETURN
      END
      SUBROUTINE MOCOC
C     ******************************************************************
C     Edit MOC output control data (called from MOCED)
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*78 COBSFL,FILTXT,FILBIN,COBSAV
      CHARACTER*60 COBFIL(MXCOB)
C     ------------------------------------------------------------------
      IOCM=1
300   CALL QRESP(MESSFL,310,17,IOCM)
      IF(IOCM.EQ.1) THEN
C  Concentration
310      CALL Q1INIT(MESSFL,310,31)
C  Send current values to screen
         CALL IVLGET('NPNTCL',0,0,ITYPE,NPNTCL)
         IF(ITYPE.NE.0) NPNTCL=0
         IFREQ=4
         IF(NPNTCL.EQ.0) IFREQ=1
         IF(NPNTCL.LE.-2) IFREQ=2
         IF(NPNTCL.EQ.-1) IFREQ=3
         CALL QSETCO(1,IFREQ)
         CALL IVLGET('ICONFM',0,0,ITYPE,ICONFM)
         IF(ITYPE.NE.0) ICONFM=0
         CALL QSETI(1,ICONFM)
         CALL FNDMFL(FILTXT,'CNCA',IUCNCA)
         CALL FNDMFL(FILBIN,'CNCB',IUCNCB)
         CALL QSTCTF(2,78,FILTXT)
         CALL QSTCTF(3,78,FILBIN)
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 310
C  Get values from screen
         CALL QGETI(1,ICONFM)
         CALL IVLSAV('ICONFM',0,0,ICONFM)
         CALL QGTCTF(2,78,FILTXT)
         CALL USTLFT(FILTXT,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILTXT,78)
         CALL PUTMFL(FILTXT,'CNCA',IUCNCA,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         CALL QGTCTF(3,78,FILBIN)
         CALL USTLFT(FILBIN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILBIN,78)
         CALL PUTMFL(FILBIN,'CNCB',IUCNCB,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         CALL QGETCO(1,IFREQ)
         IF(IFREQ.EQ.4) THEN
C  Get frequency interval
320         IF(NPNTCL.LT.1) NPNTCL=5
            CALL Q1INIT(MESSFL,310,32)
            CALL QSETI(1,NPNTCL)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 320
            CALL QGETI(1,NPNTCL)
         ELSE IF(IFREQ.EQ.3) THEN
            NPNTCL=-1
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTCL=-2
         ELSE
            NPNTCL=0
         END IF
         CALL IVLSAV('NPNTCL',0,0,NPNTCL)
C
      ELSE IF(IOCM.EQ.2) THEN
C  Velocity
410      CALL Q1INIT(MESSFL,310,33)
C  Send current values to screen
         CALL IVLGET('NPNTVL',0,0,ITYPE,NPNTVL)
         IF(ITYPE.NE.0) NPNTVL=0
         IFREQ=3
         IF(NPNTVL.EQ.0) IFREQ=1
         IF(NPNTVL.LE.-1) IFREQ=2
         CALL QSETCO(1,IFREQ)
         CALL IVLGET('ICONFM',0,0,ITYPE,ICONFM)
         IF(ITYPE.NE.0) ICONFM=0
         CALL QSETI(1,ICONFM)
         CALL FNDMFL(FILTXT,'VELA',IUVELA)
         CALL FNDMFL(FILBIN,'VELB',IUVELB)
         CALL QSTCTF(2,78,FILTXT)
         CALL QSTCTF(3,78,FILBIN)
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 410
C  Get values from screen
         CALL QGETI(1,ICONFM)
         CALL IVLSAV('ICONFM',0,0,ICONFM)
         CALL QGTCTF(2,78,FILTXT)
         CALL USTLFT(FILTXT,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILTXT,78)
         CALL PUTMFL(FILTXT,'VELA',IUVELA,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 410
         CALL QGTCTF(3,78,FILBIN)
         CALL USTLFT(FILBIN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILBIN,78)
         CALL PUTMFL(FILBIN,'VELB',IUVELB,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 410
         CALL QGETCO(1,IFREQ)
         IF(IFREQ.EQ.3) THEN
C  Get frequency interval
420         IF(NPNTVL.LT.1) NPNTVL=5
            CALL Q1INIT(MESSFL,310,34)
            CALL QSETI(1,NPNTVL)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 420
            CALL QGETI(1,NPNTVL)
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTVL=-1
         ELSE
            NPNTVL=0
         END IF
         CALL IVLSAV('NPNTVL',0,0,NPNTVL)
C
      ELSE IF(IOCM.EQ.3) THEN
C  Dispersion
510      CALL Q1INIT(MESSFL,310,35)
C  Send current values to screen
         CALL IVLGET('NPNTDL',0,0,ITYPE,NPNTDL)
         IF(ITYPE.NE.0) NPNTDL=0
         IFREQ=4
         IF(NPNTDL.EQ.0) IFREQ=1
         IF(NPNTDL.LE.-2) IFREQ=3
         IF(NPNTDL.EQ.-1) IFREQ=2
         CALL QSETCO(1,IFREQ)
         CALL IVLGET('ICONFM',0,0,ITYPE,ICONFM)
         IF(ITYPE.NE.0) ICONFM=0
         CALL QSETI(1,ICONFM)
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 510
C  Get values from screen
         CALL QGETI(1,ICONFM)
         CALL IVLSAV('ICONFM',0,0,ICONFM)
         CALL QGETCO(1,IFREQ)
         IF(IFREQ.EQ.4) THEN
C  Get frequency interval
520         IF(NPNTDL.LT.1) NPNTDL=5
            CALL Q1INIT(MESSFL,310,36)
            CALL QSETI(1,NPNTDL)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 520
            CALL QGETI(1,NPNTDL)
         ELSE IF(IFREQ.EQ.3) THEN
            NPNTDL=-2
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTDL=-1
         ELSE
            NPNTDL=0
         END IF
         CALL IVLSAV('NPNTDL',0,0,NPNTDL)
C
      ELSE IF(IOCM.EQ.4) THEN
C  Particle locations
610      CALL Q1INIT(MESSFL,310,37)
C  Send current values to screen
         CALL IVLGET('NPNTPL',0,0,ITYPE,NPNTPL)
         IF(ITYPE.NE.0) NPNTPL=0
         IFREQ=4
         IF(NPNTPL.EQ.0) IFREQ=1
         IF(NPNTPL.LE.-2) IFREQ=2
         IF(NPNTPL.EQ.-1) IFREQ=3
         CALL QSETCO(1,IFREQ)
         CALL FNDMFL(FILTXT,'PRTA',IUPRTA)
         CALL FNDMFL(FILBIN,'PRTB',IUPRTB)
         CALL QSTCTF(2,78,FILTXT)
         CALL QSTCTF(3,78,FILBIN)
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 610
C  Get values from screen
         CALL QGTCTF(2,78,FILTXT)
         CALL USTLFT(FILTXT,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILTXT,78)
         CALL PUTMFL(FILTXT,'PRTA',IUPRTA,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 610
         CALL QGTCTF(3,78,FILBIN)
         CALL USTLFT(FILBIN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILBIN,78)
         CALL PUTMFL(FILBIN,'PRTB',IUPRTB,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 610
         CALL QGETCO(1,IFREQ)
         IF(IFREQ.EQ.4) THEN
C  Get frequency interval
620         IF(NPNTPL.LT.1) NPNTPL=5
            CALL Q1INIT(MESSFL,310,38)
            CALL QSETI(1,NPNTPL)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 620
            CALL QGETI(1,NPNTPL)
         ELSE IF(IFREQ.EQ.3) THEN
            NPNTPL=-1
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTPL=-2
         ELSE
            NPNTPL=0
         END IF
         CALL IVLSAV('NPNTPL',0,0,NPNTPL)
C
      ELSE IF(IOCM.EQ.5) THEN
C  Observation sites -- Get observation file name
770      CALL Q1INIT(MESSFL,310,19)
         IF(IUCOBS.EQ.0) THEN
            IF(IUCASE.NE.0) COBSFL=DSNAME(1:NDSNAM)//'.OBS'
            IF(IUCASE.EQ.0) COBSFL=DSNAME(1:NDSNAM)//'.obs'
         ELSE
            COBSFL=FILNAM(IUCOBS)
         END IF
         CALL QSTCTF(1,78,COBSFL)
         CALL IVLGET('IOBSFL',0,0,ITYPE,IOBSFL)
         IF(ITYPE.NE.0) IOBSFL=0
         COBSAV=' '
         IF(IOBSFL.GT.0) COBSAV=FILNAM(IOBSFL)
         CALL QSTCTF(2,78,COBSAV)
C
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 770
C
         CALL QGTCTF(1,78,COBSFL)
         IF(COBSFL.EQ.' ') THEN
            IUCOBS=0
            GO TO 791
         END IF
         CALL USTLFT(COBSFL,78)
         IF(IUCASE.NE.0) CALL USTRUC(COBSFL,78)
         CALL FNMSV4(COBSFL,IU,'OBS',IUMOC)
         IF(IU.LT.0) GO TO 770
         IUCOBS=IU
         CALL QGTCTF(2,78,COBSAV)
         IF(COBSAV.EQ.' ') THEN
            IOBSFL=0
         ELSE
            CALL USTLFT(COBSAV,78)
            IF(IUCASE.NE.0) CALL USTRUC(COBSAV,78)
            CALL FNMSV4(COBSAV,IU,'DATA',IUMOC)
            IF(IU.LT.0) GO TO 770
            IOBSFL=IU
         END IF
         CALL IVLSAV('IOBSFL',0,0,IOBSFL)
C  Get observation sites
         IF(IOBSFL.EQ.0) THEN
C  Observations go into multiple files -- Get list of layer, row,
C   col, file name
780         CALL Q2INIT(MESSFL,310,18)
            CALL Q2SETI(3,MXCOB,ICOB)
C  Convert file unit to file name
            DO 782 I=1,MXCOB
               COBFIL(I)=' '
               IF(ICOBFL(I).NE.0) COBFIL(I)=FILNAM(ICOBFL(I))
782         CONTINUE
            CALL Q2STCT(1,60,60,MXCOB,COBFIL)
            CALL Q2EDIT(MXCOB,IRET)
            IF(IRET.EQ.-1) GO TO 780
            CALL Q2GETI(3,MXCOB,ICOB)
            CALL Q2GTCT(1,60,60,MXCOB,COBFIL)
C  Convert file names to file units -- substitute prior name for blank names
            DO 790 I=1,MXCOB
            IF(ICOB(1,I).GE.ISLAY1 .AND. ICOB(1,I).LE.ISLAY2 .AND.
     1         ICOB(2,I).GE.ISROW1 .AND. ICOB(2,I).LE.ISROW2 .AND.
     2         ICOB(3,I).GE.ISCOL1 .AND. ICOB(3,I).LE.ISCOL2) THEN
               CALL USTLFT(COBFIL(I),60)
               IF(IUCASE.NE.0) CALL USTRUC(COBFIL,60)
               IF(COBFIL(I).EQ.' ') THEN
                  ICOBFL(I)=0
                  CALL PRNTXT(MESSFL,310,24)
                  GO TO 780
               END IF
C  Check that old name is of type DATA and user MOC.  If a new name, add to
C  list of names.
               CALL FNMSV4(COBFIL(I),IU,'DATA',IUMOC)
               IF(IU.LT.0) THEN
                  ICOBFL(I)=0
                  GO TO 780
               END IF
               ICOBFL(I)=IU
            ELSE
               ICOB(1,I)=0
               ICOB(2,I)=0
               ICOB(3,I)=0
               ICOBFL(I)=0
            END IF
790         CONTINUE
         ELSE
C  Observation output goes into only a single file -- get just the locations
795         CALL Q2INIT(MESSFL,310,20)
            CALL Q2SETI(3,MXCOB,ICOB)
            CALL Q2EDIT(MXCOB,IRET)
            IF(IRET.EQ.-1) GO TO 795
            CALL Q2GETI(3,MXCOB,ICOB)
            DO 796 I=1,MXCOB
            IF(ICOB(1,I).LT.ISLAY1 .OR. ICOB(1,I).GT.ISLAY2 .OR.
     1         ICOB(2,I).LT.ISROW1 .OR. ICOB(2,I).GT.ISROW2 .OR.
     2         ICOB(3,I).LT.ISCOL1 .OR. ICOB(3,I).GT.ISCOL2) THEN
               ICOB(1,I)=0
               ICOB(2,I)=0
               ICOB(3,I)=0
            END IF
            ICOBFL(I)=0
796         CONTINUE
         END IF
791      CONTINUE
      ELSE
C  Done
         RETURN
      END IF
C
      IOCM=IOCM+1
      GO TO 300
C
      END
      SUBROUTINE FNDMFL(CFNAM,CFTYP,IU)
C     ******************************************************************
C     Find an existing file of a given type in the list of file names
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) CFNAM,CFTYP
C
      IU=0
      CFNAM=' '
      DO 10 I=1,MXFNAM
      IF(FILTYP(I).EQ.CFTYP) THEN
         IU=I
         CFNAM=FILNAM(I)
      END IF
10    CONTINUE
C
      RETURN
      END
      SUBROUTINE PUTMFL(CFNAM,CFTYP,IUPREV,IUPAK,IERR)
C     ******************************************************************
C     Save an MOC output file in the list of file names
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) CFNAM,CFTYP
C
      IERR=0
C
C  If there was a previous name, clear it out or keep it.
      IF(IUPREV.GT.0) THEN
         IF(FILTYP(IUPREV).EQ.CFTYP .AND. FILNAM(IUPREV).EQ.CFNAM) THEN
C  Name and type match previous name and type, so just keep these as
C  they are.  It is assumed that no other package will have these file
C  types, so an IFNUSE conflict is not checked for.
            IFNUSE(IUPREV)=IUPAK
            RETURN
         ELSE
C  Clear out old name -- this can be done because there cannot be any other
C  use for this file (unlike DATA files which can be used for multiple
C  purposes)
            FILTYP(IUPREV)=' '
            IFNUSE(IUPREV)=0
            FILNAM(IUPREV)=' '
            CALL RTRNUN(IUPREV)
         END IF
      END IF
C
C  If new name is blank, we're done
      IF(CFNAM.EQ.' ') RETURN
C
C  Put new name into file name list
      CALL FNMSV4(CFNAM,IU,CFTYP,IUPAK)
      IF(IU.LT.0) IERR=1
C
      RETURN
      END
      SUBROUTINE LAYARR(LOC,IRET,CAR)
C     ******************************************************************
C     Edit a layer array
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*(*) CAR
      CHARACTER*78 LABEL
      CHARACTER*5 CLAY(200)
      DIMENSION NL(200)
C     ------------------------------------------------------------------
C  Initialize screen
      CALL Q2INIT(MESSFL,310,39)
C  Generate flow model and transport subgrid layer numbers
      IF(CAR.NE.'CINFL') THEN
         DO 520 K=1,NSLAY
         NL(K)=K-1+ISLAY1
         WRITE(CLAY(K),'(I5)') K
520      CONTINUE
         NVAL=NSLAY
      ELSE
C  CINFL has special subgrid layer numbers
         K=0
         IF(ISCOL1.GT.1 .OR. ISCOL2.LT.NCOL .OR.
     1         ISROW1.GT.1 .OR. ISROW2.LT.NROW) THEN
            DO 530 I=1,NSLAY
            K=K+1
            NL(K)=ISLAY1-1+I
            WRITE(CLAY(K),'(I5)') I
530         CONTINUE
         END IF
         IF(ISLAY1.GT.1) THEN
            K=K+1
            NL(K)=ISLAY1-1
            CLAY(K)='ABOVE'
         END IF
         IF(ISLAY2.LT.NLAY) THEN
            K=K+1
            NL(K)=ISLAY2+1
            CLAY(K)='BELOW'
         END IF
         NVAL=ICINFL
      END IF
C  Send initial values to screen
      CALL Q2STIB(1,1,NVAL,NL)
      CALL Q2SCTF(1,5,NVAL,CLAY)
      CALL Q2STRB(1,1,NVAL,X(LOC))
C  Get values
      CALL Q2EDIT(NVAL,IRET)
      IF(IRET.EQ.-1) RETURN
      CALL Q2GTRB(1,1,NVAL,X(LOC))
C
      RETURN
      END
