      SUBROUTINE PCGAL
C     ******************************************************************
C     ALLOCATE STORAGE IN THE X ARRAY FOR PCG ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IN=IUNIT(13)
C
C-------PRINT A MESSAGE IDENTIFYING PCG PACKAGE
      WRITE(IOUT,1) IN
    1 FORMAT(1H0,'PCG -- CONJUGATE GRADIENT SOLUTION PACKAGE,',
     1' INPUT READ FROM UNIT',I3)
C
C-------READ AND PRINT MXITER,ITER1 AND NPCOND
      READ(IUREAL(IN),2) MXITER,ITER1,NPCOND
    2 FORMAT(3I10)
      WRITE(IOUT,3) MXITER,ITER1,NPCOND
    3 FORMAT(' MAXIMUM OF',I4,' CALLS OF SOLUTION ROUTINE'/
     1       ,' MAXIMUM OF',I4,' INTERNAL ITERATIONS PER '
     2       ,'CALL TO SOLUTION ROUTINE'/
     3       ,' MATRIX PRECONDITIONING TYPE :',I5)
      CALL IVLSAV('MXIPCG',0,0,MXITER)
      CALL IVLSAV('ITER1',0,0,ITER1)
C
C-------RETURN
      RETURN
      END
      SUBROUTINE PCGRP
C
C     ******************************************************************
C     READ DATA FOR PCG
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IN=IUNIT(13)
C
C-------READ HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,MUTPCG
      READ(IUREAL(IN),1) HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,MUTPCG,IPCGCD
    1 FORMAT(3F10.0,4I10)
      CALL IVLGET('MXIPCG',0,0,ITYPE,MXITER)
      CALL IVLGET('ITER1',0,0,ITYPE,ITER1)
      NPCOND=1
C
C-------PRINT MXITER,ITER1,NPCOND,HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,
C-------MUTPCG, IPCGCD
      WRITE(IOUT,100)
  100 FORMAT(1H0,///57X,'SOLUTION BY THE CONJUGATE-GRADIENT METHOD'
     1/57X,43('-'))
      WRITE(IOUT,115) MXITER
  115 FORMAT(1H0,38X,'MAXIMUM NUMBER OF CALLS TO PCG ROUTINE =',I9)
      WRITE(IOUT,120) ITER1
  120 FORMAT(1H ,42X,'MAXIMUM ITERATIONS PER CALL TO PCG =',I9)
      WRITE(IOUT,122) NPCOND
  122 FORMAT(1H ,49X,'MATRIX PRECONDITIONING TYPE =',I9)
      IF(NPCOND.EQ.2) WRITE(IOUT,123)
  123 FORMAT(1H ,58X,'THE MATRIX WILL BE SCALED')
      WRITE(IOUT,124) RELAX,NBPOL
  124 FORMAT(1H ,26X,'RELAXATION FACTOR (ONLY USED WITH',
     1' PRECOND. TYPE 1) =',E15.5,/,
     2 1H ,19X,'PARAMETER OF POLYMOMIAL PRECOND.'
     3 ,' = 2 (2) OR IS CALCULATED :',I9)
      WRITE(IOUT,125) HCLOSE
  125 FORMAT(1H ,43X,'HEAD CHANGE CRITERION FOR CLOSURE =',E15.5)
      WRITE(IOUT,127) RCLOSE
  127 FORMAT(1H ,39X,'RESIDUAL CHANGE CRITERION FOR CLOSURE =',E15.5)
      IF(IPRPCG.LE.0)IPRPCG=999
      WRITE(IOUT,130) IPRPCG,MUTPCG
  130 FORMAT(1H ,30X,'PCG HEAD AND RESIDUAL CHANGE PRINTOUT INTERVAL ='
     1,I9,/,1H ,30X,'ALL PRINTING FROM THE SOLVER IS SUPPRESSED (1) ='
     2,I9)
      WRITE(IOUT,135) IPCGCD
  135 FORMAT(1H ,5X,'FOR NPCOND=1, DO (0) OR DO NOT (1) RECALC.',
     1  ' CHOL. DIAG. EACH OUTER ITER. =',I9,/)
      CALL VALSAV('HCLPCG',0,0,HCLOSE)
      CALL VALSAV('RCLOSE',0,0,RCLOSE)
      CALL VALSAV('RELAX',0,0,RELAX)
      CALL IVLSAV('IPRPCG',0,0,IPRPCG)
      CALL IVLSAV('MUTPCG',0,0,MUTPCG)
C
      RETURN
      END
      SUBROUTINE SIPAL
C
C     ******************************************************************
C     ALLOCATE STORAGE IN THE X ARRAY FOR SIP ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IN=IUNIT(9)
C
C1------PRINT A MESSAGE IDENTIFYING SIP PACKAGE
      WRITE(IOUT,1)IN
    1 FORMAT(1X,
     1   /1X,'SIP -- STRONGLY IMPLICIT PROCEDURE SOLUTION PACKAGE',
     2   /20X,' INPUT READ FROM UNIT',I3)
C
C2------READ AND PRINT MXITER AND NPARM
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(2I10)') MXITER,NPARM
      IF(MODINP.NE.0) READ(IUREAL(IN),*) MXITER,NPARM
      WRITE(IOUT,3) MXITER,NPARM
    3 FORMAT(1X,'MAXIMUM OF',I4,' ITERATIONS ALLOWED FOR CLOSURE'/
     1       1X,I2,' ITERATION PARAMETERS')
      CALL IVLSAV('MXISIP',0,0,MXITER)
      CALL IVLSAV('NPARM',0,0,NPARM)
C
C5------RETURN
      RETURN
      END
      SUBROUTINE SIPRP
C
C     ******************************************************************
C     READ DATA FOR SIP
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IN=IUNIT(9)
      CALL IVLGET('MXISIP',0,0,ITYPE,MXITER)
C
C1------READ ACCL,HCLOSE,WSEED,IPCALC,IPRSIP
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(2F10.0,I10,F10.0,I10)')
     1                                   ACCL,HCLOSE,IPCALC,WSEED,IPRSIP
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ACCL,HCLOSE,IPCALC,WSEED,IPRSIP
      ZERO=0.
      IF(ACCL.EQ.ZERO) ACCL=1.
C
C2------PRINT DATA VALUES JUST READ
      WRITE(IOUT,100)
  100 FORMAT(1X,///10X,'SOLUTION BY THE STRONGLY IMPLICIT PROCEDURE'
     1/10X,43('-'))
      WRITE(IOUT,115) MXITER
  115 FORMAT(1X,'MAXIMUM ITERATIONS ALLOWED FOR CLOSURE =',I9)
      WRITE(IOUT,120) ACCL
  120 FORMAT(1X,16X,'ACCELERATION PARAMETER =',G15.5)
      WRITE(IOUT,125) HCLOSE
  125 FORMAT(1X,5X,'HEAD CHANGE CRITERION FOR CLOSURE =',E15.5)
      IF(IPRSIP.LE.0)IPRSIP=999
      WRITE(IOUT,130) IPRSIP
  130 FORMAT(1X,5X,'SIP HEAD CHANGE PRINTOUT INTERVAL =',I9)
      CALL VALSAV('HCLSIP',0,0,HCLOSE)
      CALL VALSAV('ACLSIP',0,0,ACCL)
      IF(IPCALC.NE.0) WSEED=0.0
      CALL VALSAV('WSEED',0,0,WSEED)
      CALL IVLSAV('IPRSIP',0,0,IPRSIP)
C
C4------RETURN
 1000 RETURN
      END
      SUBROUTINE SORAL
C
C     ******************************************************************
C     ALLOCATE STORAGE FOR SOR ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IN=IUNIT(11)
C
C1------PRINT A MESSAGE IDENTIFYING SOR PACKAGE
      WRITE(IOUT,1)IN
    1 FORMAT(1X,
     1  /1X,'SOR -- SLICE-SUCCESSIVE OVERRELAXATION SOLUTION PACKAGE',
     2  /20X,' INPUT READ FROM UNIT',I3)
C
C2------READ AND PRINT MXITER (MAXIMUM # OF ITERATIONS)
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') MXITER
      IF(MODINP.NE.0) READ(IUREAL(IN),*) MXITER
      WRITE(IOUT,3) MXITER
    3 FORMAT(1X,I5,' ITERATIONS ALLOWED FOR SOR CLOSURE')
      CALL IVLSAV('MXISOR',0,0,MXITER)
C
C5------RETURN
      RETURN
      END
      SUBROUTINE SORRP
C
C     ******************************************************************
C     READ PARAMETERS FOR SOR
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IN=IUNIT(11)
      CALL IVLGET('MXISOR',0,0,ITYPE,MXITER)
C
C1------READ THE ACCELERATION PARAMETER/RELAXATION FACTOR (ACCL) THE
C1------CLOSURE CRITERION (HCLOSE) AND THE NUMBER OF TIME STEPS
C1------BETWEEN PRINTOUTS OF MAXIMUM HEAD CHANGES (IPRSOR).
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(2F10.0,I10)') ACCL,HCLOSE,IPRSOR
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ACCL,HCLOSE,IPRSOR
      ZERO=0.
      IF(ACCL.EQ.ZERO) ACCL=1.
      IF(IPRSOR.LT.1) IPRSOR=999
C
C2------PRINT ACCL, HCLOSE, IPRSOR
      WRITE(IOUT,100)
  100 FORMAT(1X,///10X,'SOLUTION BY SLICE-SUCCESSIVE OVERRELAXATION'
     1    /10X,43('-'))
      WRITE(IOUT,115) MXITER
  115 FORMAT(1X,'MAXIMUM ITERATIONS ALLOWED FOR CLOSURE =',I9)
      WRITE(IOUT,120) ACCL
  120 FORMAT(1X,16X,'ACCELERATION PARAMETER =',G15.5)
      WRITE(IOUT,125) HCLOSE
  125 FORMAT(1X,5X,'HEAD CHANGE CRITERION FOR CLOSURE =',E15.5)
      WRITE(IOUT,130) IPRSOR
  130 FORMAT(1X,5X,'SOR HEAD CHANGE PRINTOUT INTERVAL =',I9)
      CALL VALSAV('HCLSOR',0,0,HCLOSE)
      CALL VALSAV('ACLSOR',0,0,ACCL)
      CALL IVLSAV('IPRSOR',0,0,IPRSOR)
C
C3------RETURN
      RETURN
      END
      SUBROUTINE DE4AL
C     ******************************************************************
C     ALLOCATE STORAGE FOR D4 ARRAYS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      INDE4=IUNIT(10)
C
C1------PRINT A MESSAGE IDENTIFYING DE4 PACKAGE.
      WRITE(IOUT,1) INDE4
    1 FORMAT(1X,/1X,'DE45 -- D4 DIRECT SOLUTION PACKAGE',
     1    ', VERSION 5, 7/1/93  INPUT READ FROM UNIT',I3)
C
C3------READ AND PRINT ITMX, MXUP, MXLOW, MXBW.  FOR ANY
C3------INVALID VALUES, SUBSTITUE AN APPROPRIATE VALUE.
      READ(INDE4,*) ITMX,MXUP,MXLOW,MXBW
      IF(ITMX.LT.1) ITMX=1
      WRITE(IOUT,3) ITMX
    3 FORMAT(1X,'MAXIMUM ITERATIONS (EXTERNAL OR INTERNAL) =',I3)
      IF(MXUP.LT.0) MXUP=0
      IF(MXLOW.LT.0) MXLOW=0
      IF(MXBW.LT.0) MXBW=0
      WRITE(IOUT,4) MXUP,MXLOW,MXBW
    4 FORMAT(1X,'MAXIMUM EQUATIONS IN UPPER PART:',I7,/
     1       1X,'MAXIMUM EQUATIONS IN LOWER PART:',I7,/
     2       1X,'MAXIMUM BAND WIDTH+1 OF [AL]:',I5)
C
      CALL IVLSAV('ITMX',0,0,ITMX)
      CALL IVLSAV('MXUP',0,0,MXUP)
      CALL IVLSAV('MXLOW',0,0,MXLOW)
      CALL IVLSAV('MXBW',0,0,MXBW)
C
      RETURN
      END
      SUBROUTINE DE4RP
C     ******************************************************************
C     READ DATA FOR DE4
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      INDE4=IUNIT(10)
C
C1------READ IFREQ, MUTD4, ACCL, HCLOSE, AND IPRD4
      ONE=1.
      ZERO=0.
      READ(INDE4,*) IFREQ,MUTD4,ACCL,HCLOSE,IPRD4
      IF(ACCL.LE.ZERO) ACCL=ONE
      IF(IPRD4.LE.0) IPRD4=999
      IF(MUTD4.LT.0 .OR. MUTD4.GT.2) MUTD4=0
      IF(IFREQ.LT.1 .OR. IFREQ.GT.3) THEN
         WRITE(IOUT,11) IFREQ
   11    FORMAT(1H0,'INVALID VALUE FOR IFREQ PARAMETER:',I8)
         STOP
      END IF
C
      CALL IVLSAV('IFREQ',0,0,IFREQ)
      CALL IVLSAV('MUTD4',0,0,MUTD4)
      CALL VALSAV('ACLDE4',0,0,ACCL)
      CALL VALSAV('HCLDE4',0,0,HCLOSE)
      CALL IVLSAV('IPRD4',0,0,IPRD4)
C
      RETURN
      END
      SUBROUTINE SOLVED
C  *********************************************************************
C  Input Solver data
C  *********************************************************************
      INCLUDE 'mfi.gbl'
C
      IF(IUNIT(13).NE.0) THEN
         ISOLV=1
      ELSE IF(IUNIT(9).NE.0) THEN
         ISOLV=2
      ELSE IF(IUNIT(11).NE.0) THEN
         ISOLV=3
      ELSE IF(IUNIT(10).NE.0) THEN
         ISOLV=4
      ELSE
         ISOLV=1
         CALL FINDUN(23,IU,'PCG')
         IUNIT(13)=IU
      END IF
C
C  Main Solver menu
      IOPT=1
10    CALL QRESP(MESSFL,305,1,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  Edit solver option
         CALL QRESP(MESSFL,305,2,ISOLV)
         IF(ISOLV.EQ.1) THEN
C  If this is a change from what was previously selected, open a
C  file for new solver, deselect previous solver, and remove unused
C  files.
            IF(IUNIT(13).EQ.0) THEN
               CALL FINDUN(23,IU,'PCG')
               IUNIT(13)=IU
               IF(IUNIT(9).NE.0) THEN
                  IFNUSE(IUNIT(9))=0
                  IUNIT(9)=0
               END IF
               IF(IUNIT(10).NE.0) THEN
                  IFNUSE(IUNIT(10))=0
                  IUNIT(10)=0
               END IF
               IF(IUNIT(11).NE.0) THEN
                  IFNUSE(IUNIT(11))=0
                  IUNIT(11)=0
               END IF
               CALL FNMRMV
            END IF
         ELSE IF(ISOLV.EQ.2) THEN
            IF(IUNIT(9).EQ.0) THEN
               CALL FINDUN(19,IU,'SIP')
               IUNIT(9)=IU
               IF(IUNIT(13).NE.0) THEN
                  IFNUSE(IUNIT(13))=0
                  IUNIT(13)=0
               END IF
               IF(IUNIT(10).NE.0) THEN
                  IFNUSE(IUNIT(10))=0
                  IUNIT(10)=0
               END IF
               IF(IUNIT(11).NE.0) THEN
                  IFNUSE(IUNIT(11))=0
                  IUNIT(11)=0
               END IF
               CALL FNMRMV
            END IF
         ELSE IF(ISOLV.EQ.3) THEN
            IF(IUNIT(11).EQ.0) THEN
               CALL FINDUN(21,IU,'SOR')
               IUNIT(11)=IU
               IF(IUNIT(13).NE.0) THEN
                  IFNUSE(IUNIT(13))=0
                  IUNIT(13)=0
               END IF
               IF(IUNIT(9).NE.0) THEN
                  IFNUSE(IUNIT(9))=0
                  IUNIT(9)=0
               END IF
               IF(IUNIT(10).NE.0) THEN
                  IFNUSE(IUNIT(10))=0
                  IUNIT(10)=0
               END IF
               CALL FNMRMV
            END IF
         ELSE
            IF(IUNIT(10).EQ.0) THEN
               CALL FINDUN(20,IU,'DE4')
               IUNIT(10)=IU
               IF(IUNIT(13).NE.0) THEN
                  IFNUSE(IUNIT(13))=0
                  IUNIT(13)=0
               END IF
               IF(IUNIT(9).NE.0) THEN
                  IFNUSE(IUNIT(9))=0
                  IUNIT(9)=0
               END IF
               IF(IUNIT(11).NE.0) THEN
                  IFNUSE(IUNIT(11))=0
                  IUNIT(11)=0
               END IF
               CALL FNMRMV
            END IF
         END IF
C
      ELSE IF(IOPT.EQ.2) THEN
C  Edit solver data
C
         IF(ISOLV.EQ.1) THEN
C  PCG
15          CALL Q1INIT(MESSFL,305,3)
            CALL IVLGET('MXIPCG',0,0,ITYPE,MXIPCG)
            IF(ITYPE.NE.0) MXIPCG=15
            CALL QSETIB(1,1,MXIPCG)
            CALL IVLGET('ITER1',0,0,ITYPE,ITER1)
            IF(ITYPE.NE.0) ITER1=20
            CALL QSETIB(1,2,ITER1)
            CALL IVLGET('IPRPCG',0,0,ITYPE,IPRPCG)
            IF(ITYPE.NE.0) IPRPCG=1
            CALL QSETIB(1,3,IPRPCG)
            CALL IVLGET('MUTPCG',0,0,ITYPE,MUTPCG)
            IF(ITYPE.NE.0) MUTPCG=1
            CALL QSETIB(1,4,MUTPCG)
            CALL VALGET('HCLPCG',0,0,ITYPE,HCLPCG)
            IF(ITYPE.NE.0) HCLPCG=.001
            CALL QSETRB(1,1,HCLPCG)
            CALL VALGET('RCLOSE',0,0,ITYPE,RCLOSE)
            IF(ITYPE.NE.0) RCLOSE=1000.
            CALL QSETRB(1,2,RCLOSE)
            CALL VALGET('RELAX',0,0,ITYPE,RELAX)
            IF(ITYPE.NE.0) RELAX=1.0
            CALL QSETRB(1,3,RELAX)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 15
            CALL QGETIB(1,1,MXIPCG)
            CALL IVLSAV('MXIPCG',0,0,MXIPCG)
            CALL QGETIB(1,2,ITER1)
            CALL IVLSAV('ITER1',0,0,ITER1)
            CALL QGETIB(1,3,IPRPCG)
            CALL IVLSAV('IPRPCG',0,0,IPRPCG)
            CALL QGETIB(1,4,MUTPCG)
            CALL IVLSAV('MUTPCG',0,0,MUTPCG)
            CALL QGETRB(1,1,HCLPCG)
            CALL VALSAV('HCLPCG',0,0,HCLPCG)
            CALL QGETRB(1,2,RCLOSE)
            CALL VALSAV('RCLOSE',0,0,RCLOSE)
            CALL QGETRB(1,3,RELAX)
            CALL VALSAV('RELAX',0,0,RELAX)
         ELSE IF(ISOLV.EQ.2) THEN
C  SIP
20          CALL Q1INIT(MESSFL,305,4)
            CALL IVLGET('MXISIP',0,0,ITYPE,MXISIP)
            IF(ITYPE.NE.0) MXISIP=50
            CALL QSETIB(1,1,MXISIP)
            CALL IVLGET('IPRSIP',0,0,ITYPE,IPRSIP)
            IF(ITYPE.NE.0) IPRSIP=1
            CALL QSETIB(1,2,IPRSIP)
            CALL VALGET('HCLSIP',0,0,ITYPE,HCLSIP)
            IF(ITYPE.NE.0) HCLSIP=.001
            CALL QSETRB(1,1,HCLSIP)
            CALL VALGET('WSEED',0,0,ITYPE,WSEED)
            IF(ITYPE.NE.0) WSEED=0.0
            CALL QSETRB(1,3,WSEED)
            CALL VALGET('ACLSIP',0,0,ITYPE,ACLSIP)
            IF(ITYPE.NE.0) ACLSIP=1.0
            CALL QSETRB(1,2,ACLSIP)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 20
            CALL QGETIB(1,1,MXISIP)
            CALL IVLSAV('MXISIP',0,0,MXISIP)
            CALL QGETIB(1,2,IPRSIP)
            CALL IVLSAV('IPRSIP',0,0,IPRSIP)
            CALL QGETRB(1,1,HCLSIP)
            CALL VALSAV('HCLSIP',0,0,HCLSIP)
            CALL QGETRB(1,3,WSEED)
            CALL VALSAV('WSEED',0,0,WSEED)
            CALL QGETRB(1,2,ACLSIP)
            CALL VALSAV('ACLSIP',0,0,ACLSIP)
         ELSE IF(ISOLV.EQ.3) THEN
C  SOR
30          CALL Q1INIT(MESSFL,305,5)
            CALL IVLGET('MXISOR',0,0,ITYPE,MXISOR)
            IF(ITYPE.NE.0) MXISOR=50
            CALL QSETIB(1,1,MXISOR)
            CALL IVLGET('IPRSOR',0,0,ITYPE,IPRSOR)
            IF(ITYPE.NE.0) IPRSOR=1
            CALL QSETIB(1,2,IPRSOR)
            CALL VALGET('HCLSOR',0,0,ITYPE,HCLSOR)
            IF(ITYPE.NE.0) HCLSOR=.001
            CALL QSETRB(1,1,HCLSOR)
            CALL VALGET('ACLSOR',0,0,ITYPE,ACLSOR)
            IF(ITYPE.NE.0) ACLSOR=1.5
            CALL QSETRB(1,2,ACLSOR)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 30
            CALL QGETIB(1,1,MXISOR)
            CALL IVLSAV('MXISOR',0,0,MXISOR)
            CALL QGETIB(1,2,IPRSOR)
            CALL IVLSAV('IPRSOR',0,0,IPRSOR)
            CALL QGETRB(1,1,HCLSOR)
            CALL VALSAV('HCLSOR',0,0,HCLSOR)
            CALL QGETRB(1,2,ACLSOR)
            CALL VALSAV('ACLSOR',0,0,ACLSOR)
         ELSE
C  DE4
40          CALL Q1INIT(MESSFL,305,6)
            CALL IVLGET('IFREQ',0,0,ITYPE,IFREQ)
            IF(ITYPE.NE.0) IFREQ=3
            CALL IVLGET('ITMX',0,0,ITYPE,ITMX)
            IF(ITYPE.NE.0) THEN
               ITMX=1
               IF(IFREQ.EQ.3) ITMX=5
            END IF
            CALL QSETIB(1,1,ITMX)
            CALL QSETIB(1,5,IFREQ)
            CALL IVLGET('MXUP',0,0,ITYPE,MXUP)
            IF(ITYPE.NE.0) MXUP=0
            CALL QSETIB(1,2,MXUP)
            CALL IVLGET('MXLOW',0,0,ITYPE,MXLOW)
            IF(ITYPE.NE.0) MXLOW=0
            CALL QSETIB(1,3,MXLOW)
            CALL IVLGET('MXBW',0,0,ITYPE,MXBW)
            IF(ITYPE.NE.0) MXBW=0
            CALL QSETIB(1,4,MXBW)
            CALL IVLGET('MUTD4',0,0,ITYPE,MUTD4)
            IF(ITYPE.NE.0) MUTD4=0
            CALL QSETIB(1,6,MUTD4)
            CALL VALGET('ACLDE4',0,0,ITYPE,ACLDE4)
            IF(ITYPE.NE.0) ACLDE4=1.0
            CALL QSETRB(1,1,ACLDE4)
            CALL VALGET('HCLDE4',0,0,ITYPE,HCLDE4)
            IF(ITYPE.NE.0) HCLDE4=.01
            CALL QSETRB(1,2,HCLDE4)
            CALL IVLGET('IPRD4',0,0,ITYPE,IPRD4)
            IF(ITYPE.NE.0) IPRD4=1
            CALL QSETIB(1,7,IPRD4)
            CALL Q1EDIT(IRET)
            IF(IRET.EQ.-1) GO TO 40
            CALL QGETIB(1,1,ITMX)
            CALL IVLSAV('ITMX',0,0,ITMX)
            CALL QGETIB(1,2,MXUP)
            CALL IVLSAV('MXUP',0,0,MXUP)
            CALL QGETIB(1,3,MXLOW)
            CALL IVLSAV('MXLOW',0,0,MXLOW)
            CALL QGETIB(1,4,MXBW)
            CALL IVLSAV('MXBW',0,0,MXBW)
            CALL QGETIB(1,5,IFREQ)
            CALL IVLSAV('IFREQ',0,0,IFREQ)
            CALL QGETIB(1,6,MUTD4)
            CALL IVLSAV('MUTD4',0,0,MUTD4)
            CALL QGETRB(1,1,ACLDE4)
            CALL VALSAV('ACLDE4',0,0,ACLDE4)
            CALL QGETRB(1,2,HCLDE4)
            CALL VALSAV('HCLDE4',0,0,HCLDE4)
            CALL QGETIB(1,7,IPRD4)
            CALL IVLSAV('IPRD4',0,0,IPRD4)
         END IF
C
      ELSE
C  End of Solver data input
         CALL SOLVSV(IUNDEF,1)
         RETURN
      END IF
C
      IOPT=IOPT+1
      GO TO 10
C
      END
      SUBROUTINE SOLVSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR SOLVER PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
C
10    IF(IUNIT(13).NE.0) THEN
C  PCG
         IF(IUREAL(IUNIT(13)).EQ.0) CALL REALUN(IUNIT(13))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.PCG',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(13)),UNIT=IFIL)
         CALL IVLGET('MXIPCG',0,0,ITYPE,MXIPCG)
         IF(ITYPE.NE.0) MXIPCG=15
         CALL IVLGET('ITER1',0,0,ITYPE,ITER1)
         IF(ITYPE.NE.0) ITER1=20
         CALL IVLGET('IPRPCG',0,0,ITYPE,IPRPCG)
         IF(ITYPE.NE.0) IPRPCG=1
         CALL IVLGET('MUTPCG',0,0,ITYPE,MUTPCG)
         IF(ITYPE.NE.0) MUTPCG=1
         CALL VALGET('HCLPCG',0,0,ITYPE,HCLPCG)
         IF(ITYPE.NE.0) HCLPCG=.001
         CALL VALGET('RCLOSE',0,0,ITYPE,RCLOSE)
         IF(ITYPE.NE.0) RCLOSE=1000.
         CALL VALGET('RELAX',0,0,ITYPE,RELAX)
         IF(ITYPE.NE.0) RELAX=1.0
         IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)') MXIPCG,ITER1,
     1          '         1   MXITER  ITER1  NPCOND'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,3E10.2,A,2I10,A)')
     1         HCLPCG,RCLOSE,RELAX,'         2',IPRPCG,MUTPCG,
     2     '         0  HCLOSE RCLOSE RELAX NPBOL IPRPCG MUTPCG IPCGCD'
      ELSE IF(IUNIT(9).NE.0) THEN
C  SIP
         IF(IUREAL(IUNIT(9)).EQ.0) CALL REALUN(IUNIT(9))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.SIP',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(9)),UNIT=IFIL)
         CALL IVLGET('MXISIP',0,0,ITYPE,MXISIP)
         IF(ITYPE.NE.0) MXISIP=50
         CALL IVLGET('NPARM',0,0,ITYPE,NPARM)
         IF(ITYPE.NE.0) NPARM=5
         CALL IVLGET('IPRSIP',0,0,ITYPE,IPRSIP)
         IF(ITYPE.NE.0) IPRSIP=1
         CALL VALGET('HCLSIP',0,0,ITYPE,HCLSIP)
         IF(ITYPE.NE.0) HCLSIP=.001
         CALL VALGET('ACLSIP',0,0,ITYPE,ACLSIP)
         IF(ITYPE.NE.0) ACLSIP=1.0
         CALL VALGET('WSEED',0,0,ITYPE,WSEED)
         IF(ITYPE.NE.0) WSEED=0.0
         IPCALC=0
         IF(WSEED.EQ. 0.0) IPCALC=1
         IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)') MXISIP,NPARM,
     1                             '  MXITER  NPARM'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2E10.2,I10,E10.2,I10,A)')
     1         ACLSIP,HCLSIP,IPCALC,WSEED,IPRSIP,
     2         ' ACCL HCLOSE IPCALC WSEED IPRSIP'
      ELSE IF(IUNIT(11).NE.0) THEN
C  SOR
         IF(IUREAL(IUNIT(11)).EQ.0) CALL REALUN(IUNIT(11))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.SOR',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(11)),UNIT=IFIL)
         CALL IVLGET('MXISOR',0,0,ITYPE,MXISOR)
         IF(ITYPE.NE.0) MXISOR=50
         CALL IVLGET('IPRSOR',0,0,ITYPE,IPRSOR)
         IF(ITYPE.NE.0) IPRSOR=1
         CALL VALGET('HCLSOR',0,0,ITYPE,HCLSOR)
         IF(ITYPE.NE.0) HCLSOR=.001
         CALL VALGET('ACLSOR',0,0,ITYPE,ACLSOR)
         IF(ITYPE.NE.0) ACLSOR=1.5
         IF(IWRFLG.GT.0) WRITE(IFIL,'(I10,A)') MXISOR,'  MXITER'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2E10.2,I10,A)')
     1         ACLSOR,HCLSOR,IPRSOR,'  ACCL HCLOSE IPRSOR'
      ELSE IF(IUNIT(10).NE.0) THEN
C  DE4
         IF(IUREAL(IUNIT(10)).EQ.0) CALL REALUN(IUNIT(10))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.DE4',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(10)),UNIT=IFIL)
         CALL IVLGET('IFREQ',0,0,ITYPE,IFREQ)
         IF(ITYPE.NE.0) IFREQ=3
         CALL IVLGET('ITMX',0,0,ITYPE,ITMX)
         IF(ITYPE.NE.0) THEN
            ITMX=1
            IF(IFREQ.EQ.3) ITMX=5
         END IF
         CALL IVLGET('MXUP',0,0,ITYPE,MXUP)
         IF(ITYPE.NE.0) MXUP=1
         CALL IVLGET('MXLOW',0,0,ITYPE,MXLOW)
         IF(ITYPE.NE.0) MXLOW=1
         CALL IVLGET('MXBW',0,0,ITYPE,MXBW)
         IF(ITYPE.NE.0) MXBW=0
         CALL IVLGET('IPRD4',0,0,ITYPE,IPRD4)
         IF(ITYPE.NE.0) IPRD4=1
         CALL IVLGET('MUTD4',0,0,ITYPE,MUTD4)
         IF(ITYPE.NE.0) MUTD4=0
         CALL VALGET('HCLDE4',0,0,ITYPE,HCLDE4)
         IF(ITYPE.NE.0) HCLDE4=.01
         CALL VALGET('ACLDE4',0,0,ITYPE,ACLDE4)
         IF(ITYPE.NE.0) ACLDE4=1.
         IF(IWRFLG.GT.0) WRITE(IFIL,'(4I10,A)') ITMX,MXUP,MXLOW,MXBW,
     1                                    '   ITMX  MXUP  MXLOW  MXBW'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2I5,2E10.2,I10,A)')
     1         IFREQ,MUTD4,ACLDE4,HCLDE4,IPRD4,
     2     '   IFREQ MUTD4 ACCL HCLOSE IPRD4'
      ELSE
C  No solver selected yet -- force PCG with default values
         CALL FINDUN(23,IU,'PCG')
         IUNIT(13)=IU
         GO TO 10
      END IF

C
      IF(IFIL.GT.0) CLOSE(UNIT=IFIL)
      RETURN
      END
