      SUBROUTINE SSLST(IXLOC,NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX)
C     ******************************************************************
C     Interface for editing a list using tactician
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IXLOC(10)
      CHARACTER*(*) LABEL(NMFLOW,2)
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*8 LABEL2(3,2)
      DIMENSION ISSCOL(20),MFICOL(20)
C
C  Tell user to wait until spreadsheet is done.
      CALL PMXCNW(MESSFL,300,9,50,1,1,I)
C
C  Write existing values into spreadsheet file if they exist.  Zero
C  values after writing so that they cannot be inadvertantly reused if
C  the user leaves some fields in spreadsheet blank.  Most spreadsheets
C  do not write out blank fields.  This routine only stores fields that
C  are written, so a blank field would not get stored.  This would mean
C  that an old value could get reused if part of a row has values and
C  part is blank.  Since all old values are reset to zero, any blank
C  fields will be zero.
      DO 2 I=1,NMFLOW
      ISSCOL(I)=I
      MFICOL(I)=I
2     CONTINUE
      DO 3 I=1,3
      LABEL2(I,1)=' '
      LABEL2(I,2)=' '
      ISSCOL(NMFLOW+I)=0
3     CONTINUE
C
      NV=NMFLOW
      LSTDIM=IARRDA(3,NAR)
C
C  Activate IFACE as first AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         CAUX(1)='IFACE'
      END IF
C
C  Create spread sheet labels for AUX fields
      DO 5 I=1,NCAUX
      IF(CAUX(I).NE.' ') THEN
C  Note that only non-blank labels will be displayed as columns in the
C  spread sheet
         LABEL2(I,2)=CAUX(I)
         NV=NV+1
         ISSCOL(NMFLOW+I)=NV
         MFICOL(NV)=NMFLOW+I
      END IF
5     CONTINUE
C
C  Now create the spread sheet file
      CALL SSOPWR(IUMISC)
      CALL SSLAWR(IUMISC,LABEL(1,1),NMFLOW,LABEL2(1,1),3,1)
      CALL SSLAWR(IUMISC,LABEL(1,2),NMFLOW,LABEL2(1,2),3,2)
      IF(NLIST.GT.0) THEN
         DO 15 N=1,NLIST
         IGROUP=(N-1)/MXLIST + 1
         IOFF=IXLOC(IGROUP)+ (N-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
         DO 10 L=1,LSTDIM
         IF(ISSCOL(L).GT.0) THEN
            CALL SSWR(IUMISC,ISSCOL(L),N+2,X(IOFF + L))
            X(IOFF + L)=0.
         END IF
10       CONTINUE
15       CONTINUE
      END IF
      CLOSE(UNIT=IUMISC)
C
      CALL SYSCAL('tact tact.t')
      CALL SSOPRD(IUMISC)
      MXN=0
C
20    CALL SSRD(IUMISC,L,N,R)
      IF(L.EQ.0) GO TO 30
      N=N-2
      IF(L.LE.NV .AND. N.GT.0 .AND. N.LE.MXLIST*10) THEN
         IF(N.GT.MXN) MXN=N
         IGROUP=(N-1)/MXLIST + 1
         IF(IGROUP.GT.IARRDA(4,NAR)) CALL LSTALO(NAR,IGROUP)
         IOFF=(N-1-(IGROUP-1)*MXLIST)*LSTDIM + MFICOL(L) - 1
         X(IXLOC(IGROUP)+IOFF)=R
      END IF
      GO TO 20

30    NLIST=0
      DO 40 N=1,MXN
      IGROUP=(N-1)/MXLIST + 1
      IOFF=(N-1-(IGROUP-1)*MXLIST)*LSTDIM
      IL=X(IXLOC(IGROUP)+IOFF)
      IR=X(IXLOC(IGROUP)+IOFF+1)
      IC=X(IXLOC(IGROUP)+IOFF+2)
      IF(IC.LT.1    .OR. IR.LT.1    .OR. IL.LT.1 .OR.
     1   IC.GT.NCOL .OR. IR.GT.NROW .OR. IL.GT.NLAY) GO TO 40
      NLIST=NLIST+1
C  If there are bad values, remove them.
      IF(NLIST.NE.N) THEN
         IGRP2=(NLIST-1)/MXLIST + 1
         IOFF2=(NLIST-1-(IGRP2-1)*MXLIST)*LSTDIM
         DO 35 L=1,LSTDIM
         X(IXLOC(IGRP2)+IOFF2+L-1)=X(IXLOC(IGROUP)+IOFF+L-1)
         X(IXLOC(IGROUP)+IOFF+L-1)=0.
35       CONTINUE
      END IF
40    CONTINUE
      CALL PMXTXI(MESSFL,300,11,10,1,0,1,NLIST)
C
      RETURN
      END
      SUBROUTINE SS2DR(XX,NC,NR,LABEL)
C     ******************************************************************
C     Interface for editing a 2-D real array using tactician
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION XX(NC,NR)
      CHARACTER*(*) LABEL
C
      CALL PMXCNW(MESSFL,300,9,50,1,1,I)
C
      CALL SSOPWR(IUMISC)
      IF(NC.GT.2) CALL SSSPLT(IUMISC,NR)
      DO 11 J=1,NC
      DO 10 I=1,NR
      CALL SSWR(IUMISC,J,I,XX(J,I))
10    CONTINUE
      R=J
      IF(NC.GT.2) CALL SSWR(IUMISC,J,NR+2,R)
11    CONTINUE
      CLOSE(UNIT=IUMISC)
C
      CALL SYSCAL('tact tact.t')
C
      CALL SSOPRD(IUMISC)
      N=0
20    CALL SSRD(IUMISC,IC,IR,R)
      IF(IC.EQ.0) THEN
         NBAD=NC*NR-N
         IF(NBAD.NE.0) CALL PMXTXI(MESSFL,300,12,10,1,0,1,NBAD)
         RETURN
      END IF
      IF(IC.LE.NC .AND. IR.LE.NR .AND. IC.GT.0) THEN
         N=N+1
         XX(IC,IR)=R
      END IF
      GO TO 20
C
      END
      SUBROUTINE SS2DI(IX,NC,NR,LABEL)
C     ******************************************************************
C     Interface for editing a 2-D integer array using tactician
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IX(NC,NR)
      CHARACTER*(*) LABEL
C
      CALL PMXCNW(MESSFL,300,9,50,1,1,I)
C
      CALL SSOPWR(IUMISC)
      IF(NC.GT.2) CALL SSSPLT(IUMISC,NR)
      DO 11 J=1,NC
      DO 10 I=1,NR
      R=IX(J,I)
      CALL SSWR(IUMISC,J,I,R)
10    CONTINUE
      R=J
      IF(NC.GT.2) CALL SSWR(IUMISC,J,NR+2,R)
11    CONTINUE
      CLOSE(UNIT=IUMISC)
C
      CALL SYSCAL('tact tact.t')
C
      CALL SSOPRD(IUMISC)
      N=0
20    CALL SSRD(IUMISC,IC,IR,R)
      IF(IC.EQ.0) THEN
         NBAD=NC*NR-N
         IF(NBAD.NE.0) CALL PMXTXI(MESSFL,300,12,10,1,0,1,NBAD)
         RETURN
      END IF
      IF(IC.LE.NC .AND. IR.LE.NR .AND. IC.GT.0) THEN
         N=N+1
         IX(IC,IR)=R
      END IF
      GO TO 20
C
      END
      SUBROUTINE SSSPLT(IU,NR)
C     ******************************************************************
C     Split spreadsheet window to show numeric column numbers.
C     ******************************************************************
      CHARACTER*3 CROW
C  No point in splitting screen if there are 23 or fewer rows
      IF(NR.LE.23) RETURN
C
      WRITE(IU,'(A)') 'G25;GLR;9;128'
      WRITE(CROW,'(I3.3)') NR+2
      WRITE(IU,'(A)') 'WH1;2,0,24,92,A1,A1;26,0,2,92,A'
     1       //CROW//',A'//CROW
      RETURN
      END
      SUBROUTINE SSOPWR(IU)
C     ******************************************************************
      OPEN(UNIT=IU,FILE='tact.t',ERR=100)
      WRITE(IU,'(A)') 'V3.0'
      RETURN
C
100   WRITE(*,*) ' Error opening spreadsheet file'
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSLAWR(IU,LABEL,NMFLOW,LABEL2,NCAUX,IR)
C     ******************************************************************
      CHARACTER*(*) LABEL(NMFLOW),LABEL2(NCAUX)
      CHARACTER*40 LINE1,LINE2
      CHARACTER*1 ALPHA(27)
      DATA ALPHA/' ','A','B','C','D','E','F','G','H','I','J',
     1               'K','L','M','N','O','P','Q','R','S','T',
     2               'U','V','W','X','Y','Z'/
C
      J=0
      DO 10 JJJ=1,NMFLOW+NCAUX
      IF(JJJ.GT.NMFLOW .AND. LABEL2(JJJ-NMFLOW).EQ.' ') GO TO 10
      J=J+1
      JJ=J-1
      IC1=JJ/26
      IC2=JJ-IC1*26 +2
      IC1=IC1+1
      LINE1=' '
      LINE2=' '
      IF(JJJ.GT.NMFLOW) THEN
         WRITE(LINE1,8,ERR=100) ALPHA(IC1),ALPHA(IC2),IR,
     1                                 LABEL2(JJJ-NMFLOW)
      ELSE
         WRITE(LINE1,8,ERR=100) ALPHA(IC1),ALPHA(IC2),IR,LABEL(J)
      END IF
8     FORMAT('F',2A,I3,';TGRD;',A)
      NC=0
      DO 9 K=1,40
      IF(LINE1(K:K).NE.' ') THEN
         NC=NC+1
         LINE2(NC:NC)=LINE1(K:K)
      END IF
9     CONTINUE
      WRITE(IU,'(A)',ERR=100) LINE2(1:NC)
10    CONTINUE
      RETURN
C
100   WRITE(*,*) ' Error writing spreadsheet file'
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSWR(IU,J,I,X)
C     ******************************************************************
      CHARACTER*40 LINE1,LINE2
      CHARACTER*1 ALPHA(27)
      DATA ALPHA/' ','A','B','C','D','E','F','G','H','I','J',
     1               'K','L','M','N','O','P','Q','R','S','T',
     2               'U','V','W','X','Y','Z'/
      JJ=J-1
      IC1=JJ/26
      IC2=JJ-IC1*26 +2
      IC1=IC1+1
      LINE1=' '
      LINE2=' '
      WRITE(LINE1,8,ERR=100) ALPHA(IC1),ALPHA(IC2),I,X
8     FORMAT('F',2A,I4,';CDDD;',1PE13.5)
      NC=0
      DO 9 K=1,40
      IF(LINE1(K:K).NE.' ') THEN
         NC=NC+1
         LINE2(NC:NC)=LINE1(K:K)
      END IF
9     CONTINUE
      WRITE(IU,'(A)',ERR=100) LINE2(1:NC)
      RETURN
C
100   WRITE(*,*) ' Error writing spreadsheet file'
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSOPRD(IU)
C     ******************************************************************
      OPEN(UNIT=IU,FILE='tact.t',ERR=100)
      RETURN
C
100   WRITE(*,*) ' Error accessing spreadsheet file'
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSRD(IU,IC,IR,R)
C     ******************************************************************
      CHARACTER*80 LINE1
      CHARACTER*40 LINE2
C
30    READ(IU,'(A)',END=100,ERR=200) LINE1
      IF(LINE1(1:1).NE.'F') GO TO 30
C
      IF(LINE1(3:3).GE.'A' .AND. LINE1(3:3).LE.'Z') THEN
         IC1=ICHAR(LINE1(2:2))-ICHAR('A')+1
         IC2=ICHAR(LINE1(3:3))-ICHAR('A')+1
         L=4
      ELSE
         IC1=0
         IC2=ICHAR(LINE1(2:2))-ICHAR('A')+1
         L=3
      END IF
      IC=IC1*26+IC2
C
      L2=INDEX(LINE1,';')
      N=L2-L
      IF(N.EQ.4) THEN
         READ(LINE1(L:L+3),'(I4)',ERR=200) IR
      ELSE IF(N.EQ.3) THEN
         READ(LINE1(L:L+2),'(I3)',ERR=200) IR
      ELSE IF(N.EQ.2) THEN
         READ(LINE1(L:L+1),'(I2)',ERR=200) IR
      ELSE
         READ(LINE1(L:L+1),'(I1)',ERR=200) IR
      END IF
      L=L2+1
C  Find beginning of numeric field -- this depends on whether it is a
C  constant (C) or an equation (X)
      IF(LINE1(L:L).EQ.'X') THEN
         L=L+5
35       IF(LINE1(L:L).NE.';') THEN
            L=L+1
            GO TO 35
         END IF
         L=L+1
      ELSE IF(LINE1(L:L).EQ.'C') THEN
         L=L+5
      ELSE
         GO TO 30
      END IF
C  Look for end of numeric field, which could either be ";" or a space
C  If the number of characters in the line exceeds 79 characters, then the
C  line cannot be interpreted.
      L2=L
40    IF(LINE1(L2:L2).NE.';' .AND. LINE1(L2:L2).NE.' ') THEN
         L2=L2+1
         IF(L2.GT.80) GO TO 30
         GO TO 40
      END IF
      N=L2-L
      IF(N.GT.40 .OR. N.LT.1) GO TO 30
      L2=L2-1
      LINE2=' '
      LINE2(41-N:40)=LINE1(L:L2)
      READ(LINE2,'(F40.0)',ERR=200) R
      RETURN
C
100   CLOSE(UNIT=IU,STATUS='DELETE')
      IC=0
      RETURN
C
200   GO TO 30
      END
