      SUBROUTINE SYSCAL(COMMND)
C  Invoke a system call from FORTRAN
      CHARACTER*(*) COMMND
      EXTERNAL SYSTEM
      INTEGER SYSTEM
C
      I=SYSTEM(COMMND)
      RETURN
C
      END
      SUBROUTINE NAMARG(ARG)
C     ******************************************************************
C     Get the dataset name from a command argument if there is one
C     ******************************************************************
      EXTERNAL IARGC
      CHARACTER*(*) ARG
C
      ARG=' '
      N=IARGC()
      IF(N.GT.0) CALL GETARG(1,ARG)
      RETURN
      END
      SUBROUTINE GETPNM(FNAME)
C     ******************************************************************
C     Construct the pathname of a file from its simple file name.  This
C     routine is used to find the MFI message file, mfi.wdm.  This
C     version looks for a file named MFI.PTH; the first line of this
C     file holds the directory name for the message file.  If MFI.PTH
C     is not found, it is assumed that mfi.wdm is in the current
C     directory -- i.e. FNAME is left unchanged.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) FNAME
      CHARACTER*64 CDIR,CFILE
      LOGICAL EX
C
      INQUIRE(FILE='MFI.PTH',EXIST=EX)
      IF(EX) THEN
C  Get the directory name and prepend it to filename
         CFILE=FNAME
         OPEN(UNIT=IUMISC,FILE='MFI.PTH')
         READ(IUMISC,'(A)',END=100) CDIR
         NF=INDEX(CFILE,' ')-1
         ND=INDEX(CDIR,' ')-1
         IF(ND.GT.0) FNAME=CDIR(1:ND)//CFILE(1:NF)
         CLOSE(IUMISC)
      END IF
100   RETURN
      END
      SUBROUTINE ORGOPN
C     ******************************************************************
C     Create a file that does whatever is needed to make the original
C     MODFLOW open files.
C     Create a UNIX shell program for running MODFLOW assuming INBAS and
C     IOUT are Standard In and Out, and that FORTRAN will look for all
C     other files to be named fort.n, where n is the unit number.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*2 CUN
      CHARACTER*80 CMD
C     ------------------------------------------------------------------
C  If MODFLOW-96 is being used, no shell program is required.
      IF(MODOUT.NE.0) RETURN
C
      OPEN(FILE=DSNAME(1:NDSNAM)//'.sh',UNIT=IUMISC)
      WRITE(IUMISC,'(A)') '#'
C
C  Delete the old listing file.
      J=LENSTR(80,FILNAM(ILOUT))
      WRITE(IUMISC,4) FILNAM(ILOUT)(1:J)
4     FORMAT('if [ -f ',A,' ]')
      WRITE(IUMISC,5)
5     FORMAT('then')
      WRITE(IUMISC,6) FILNAM(ILOUT)(1:J)
6     FORMAT('rm ',A)
      WRITE(IUMISC,7)
7     FORMAT('fi')
C
C  Create symbolic links for all files except the listing and Basic
C  Package files
      DO 20 I=1,MXFNAM
      IF(IFNUSE(I).NE.0 .AND. FILTYP(I)(1:10).NE.'OPEN/CLOSE' .AND.
     1    I.NE.INBAS .AND. I.NE.ILOUT .AND. IFNUSE(I).NE.IUNIT(40)) THEN
         J=LENSTR(80,FILNAM(I))
         WRITE(CUN,'(I2)') IUREAL(I)
         IF(IUREAL(I).LT.10) THEN
            CUN(1:1)=CUN(2:2)
            CUN(2:2)=' '
         END IF
         WRITE(IUMISC,15) FILNAM(I)(1:J),CUN
15       FORMAT('ln -s ',A,' fort.',A)
      END IF
20    CONTINUE
C
C  Write the model execution command with standard input and output
C  redirected to the BAS and listing files
      J=LENSTR(80,FILNAM(ILOUT))
      K=LENSTR(80,FILNAM(INBAS))
      WRITE(IUMISC,26) FILNAM(INBAS)(1:K),FILNAM(ILOUT)(1:J)
26    FORMAT('modflow <',A,'  >',A)
C
C  Remove all the links that were made.
      DO 30 I=1,MXFNAM
      IF(IFNUSE(I).NE.0 .AND. FILTYP(I)(1:10).NE.'OPEN/CLOSE' .AND.
     1    I.NE.INBAS .AND. I.NE.ILOUT .AND. IFNUSE(I).NE.IUNIT(40)) THEN
         WRITE(CUN,'(I2)') IUREAL(I)
         IF(IUREAL(I).LT.10) THEN
            CUN(1:1)=CUN(2:2)
            CUN(2:2)=' '
         END IF
         WRITE(IUMISC,28) CUN
28       FORMAT('rm fort.',A)
      END IF
30    CONTINUE
C
C  Make the shell program executable
      CLOSE(UNIT=IUMISC)
      CMD='chmod 755 '//DSNAME(1:NDSNAM)//'.sh'
      N=LENSTR(80,CMD)
      N=N+1
      CMD(N:N)=CHAR(0)
      CALL SYSCAL(CMD(1:N))
      RETURN
      END
